DECLARE SUB PathFromFilename (InputString$, OutputPath$, OutputFilename$)
Declare FUNCTION TabExpand$ (In$)
		' This module can be Launched with a CHAIN qbasic instruction by a different qbasic program.
' Just add the same COMMON arrays to your launcher. (DIM Vector, MyName$, MyVal and the 3 corresponding COMMON Shared declarations).
' These arrays are used only as a parameter passing between chained qbasic programs.

DIM Vector(0 TO 10)      AS INTEGER
DIM MyName$(0 TO 30)
DIM MyVal(0 TO 10)      AS INTEGER

COMMON SHARED Vector() AS INTEGER
COMMON SHARED MyName$()
COMMON SHARED MyVal() AS INTEGER
		If MyName$(0) = ""  Then MyName$(0) = "Canonize.bas" : Chain "Boot.BAS"
		Cls
		PRINT "This program will canonize the LEADING TABs or Spaces of a QBasic Program"
		PRINT "After processing, each line in the QB program will have an Indenting of 2 TABs"
		
		TabLead$ = CHR$(9) + CHR$(9)
		
		BLeading$ = SPACE$(16)
		InfL$ = "inf"
		
		NIL$ = ""
		'PRINT "Source File : "; InfL$
		
		INPUT "Source File (or... just press ENTER if processing a list of files from CANON.TXT): ", InFile$
		IF LEN(InFile$) > 0 THEN InfL$ = InFile$: GOTO DoitNow
		Listfile$ = "CANON.TXT"
		OPEN Listfile$ FOR INPUT AS #3
		WHILE NOT EOF(3)
		LINE INPUT #3, Lis$
		Lis$ = TabExpand(Lis$)
		Lis$ = RTRIM$(LTRIM$(Lis$))
		IF Lis$ = "" OR LEFT$(Lis$, 1) = "'" THEN GOTO NextList
		InfL$ = Lis$
		
		
DoitNow:        CALL PathFromFilename(InfL$, Path$, Filename$) 
		Out$ = "out"
		IF Path$<>"" THEN  Out$ = Path$ +  Out$
		'PRINT "Output File : "; Out$
		'INPUT "Output File : ", OutFile$
		'IF LEN(OutFile$) > 0 THEN Out$ = OutFile$
' OPEN file$ [FOR mode] [ACCESS access] [lock] AS [#]filenumber% [LEN=reclen%]
		Inf$ = InfL$
' If INF$="Virtual.bas"

		Call ShortLongName(Inf$,CR$,1) ' Get Short Name out of a long filename
'               OPEN "I", #1, Inf$
		OPEN Inf$ FOR INPUT AS #1
'               OPEN "O", #2, Out$
		OPEN Out$ FOR OUTPUT AS #2
		
		
		WHILE NOT EOF(1)
		LINE INPUT #1, In$: Tlin& = Tlin& + 1
		In$ = TabExpand(In$)
goon:           IF LEFT$(In$, 1) <> " " THEN GOTO Skip
		In$ = TabLead$ + RTRIM$(LTRIM$(In$))
		
Skip:           PRINT Tlin&; In$
		PRINT #2, In$
avanza:
		WEND
		CLOSE #1: CLOSE #2
		KILL Inf$
		Exec$ = "REN " + Out$ + " " + InfL$ + "   "
		PRINT Exec$
		SHELL Exec$
NextList:              
		WEND
		CLOSE #3
		SYSTEM
		END

SUB PathFromFilename (InputString$, OutputPath$, OutputFilename$)
		InputString$ = RTRIM$(LTRIM$(InputString$))
		FOR T = LEN(InputString$) TO 1 STEP -1
		IF MID$(InputString$, T, 1) = "\" THEN GOTO PathFrom1
		NEXT T
		OutputPath$ = ""
		OutputFilename$ = InputString$
		GOTO PathFrom2
PathFrom1:
		OutputPath$ = LEFT$(InputString$, T)
		OutputFilename$ = MID$(InputString$, T + 1)
PathFrom2:
END SUB

SUB ShortLongName (A$,B$,FUNC As Integer)
' Get either a LongName or a Shortname, depending on the value assigned to the control variable FUNC
' FUNC = 1  -  Get ShortFilename (8.3 characters) out of a LongFilename. 
'                  Return the Longest Filename available, but don't create a new file if none exists.
'      = 2  -  Get LongFilename. 
'                  Return the Longest Filename available, but don't create a new file if none exists.
'      = 3  -  Get ShortFilename (8.3 characters) out of a LongFilename. Create one LongFilename if no ShortFilename exists.
'                  Return the shortest Filename available. If file is created, a second record containing "CR!" will be returned.
'      = 4  -  Get Long Filename out of a short one. Create a long one if none exists. 
'                  Return the longest Filename available. If file is created, a second record containing "CR!" will be returned. 
'      = 5  -  Get Long Filename out of a short one. Create a long one if none exists. 
'                  Return the shortest Filename available. If file is created, a second record containing "CR!" will be returned.

		SELECT CASE MyVal(0)
		CASE 0 TO 999  ' Plain DOS OS
		EXIT SUB
		CASE 1000 TO 1999  ' Windows 95, 98, XP
		GOTO ShortLongN1
		CASE 2000 TO 3000  ' Windows XP, Vista
		GOTO ShortLongN1
		CASE ELSE
		END SELECT
		EXIT SUB
		
ShortLongN1:    Select CASE FUNC
		CASE 1  ' Get short filename (8.3 characters) but don't create a new file.
		C$ = "INT7160.com"
		CASE 2  ' Get Longest Filename but don't create a new file.
		C$ = "INT716RL.com"
		CASE 3  ' Get ShortFilename and create a long one if none exists. Return the short one anyway
		C$ = "INT716C.com"
		CASE 4  ' Get Long Filename out of a short one. Create a long one if none exists.
		C$ = "INT716CO.com"  ' The new  filename returned to the caller will be of the longest type available.
		CASE 5  ' Get Long Filename out of a short one. Create a long one if none exists.
		C$ = "INT716CL.com"  ' The new  filename returned to the caller will be of the shortest type available.

		CASE Else
		Exit Sub
		END SELECT
		
		
		C$ = C$ + " " + A$ + " >--"'Redirect output to a file named "--"
		SHELL C$
		B$=""
		ff% = FREEFILE
		OPEN "--" FOR INPUT AS #ff%
		IF EOF(ff%) <> 0 THEN GOTO ShortLongN2
		LINE INPUT #ff%, A$
		IF EOF(ff%) <> 0 THEN GOTO ShortLongN2
		LINE INPUT #ff%, B$
ShortLongN2:    CLOSE #ff%
		KILL "--"
END Sub

FUNCTION TabExpand$ (In$)
' Replace TAB characters [CHR$(9)] with blankes            
' Rule: each TAB adds as many blanks as they are missing from the next 8th position

TAB10:          P = INSTR(In$, CHR$(9))
		IF P = 0 THEN GOTO TAB30
		Howmany = P - 1
		IF Howmany < 8 THEN GOTO TAB20
		Howmany = Howmany MOD 8
		
TAB20:          Howmany = 8 - Howmany
		In$ = LEFT$(In$, P - 1) + SPACE$(Howmany) + MID$(In$, P + 1, LEN(In$))
		GOTO TAB10
TAB30:          TabExpand$ = In$
		
END FUNCTION

