' This module can Launch different qbasic programs with a CHAIN qbasic instruction.
' Just add the same COMMON arrays to your launcher. (DIM Vector, MyName$, MyVal and the 3 corresponding COMMON Shared declarations).
' These arrays are used only as a parameter passing between chained qbasic programs.
' 
' To be added
' 1) Error Message as to why some files don't qualify and will be left out
' 2) Give user the chance to choose if he wants to exclude files with sector 1 not matching (above NextMerge: )
' 3) Error Message if there aren't at least 2 file to work upon (below NotMerge: )
'
DIM Vector(0 TO 10)      AS INTEGER
DIM MyName$(0 TO 30)
DIM MyVal(0 TO 10)      AS INTEGER'

COMMON SHARED Vector() AS INTEGER
COMMON SHARED MyName$()
COMMON SHARED MyVal() AS INTEGER

                DIM SHARED FileNum AS INTEGER
                DIM SHARED FC AS INTEGER
                DIM SHARED BC AS INTEGER
                DIM SHARED HFC AS INTEGER
                DIM SHARED HBC AS INTEGER
                
                DIM SHARED Gap1%            ' Start of track Gap
                DIM SHARED PreIDGap%           '
                DIM SHARED PreDatGap%
                DIM SHARED SLength%
                DIM SHARED TrkLen&
                DIM SHARED TrackSing(1) AS STRING * 3253
                DIM SHARED TrackDoub(1) AS STRING * 6872
                DIM SHARED V9T9Sekt(1) AS STRING * 256
                DIM SHARED OldTrack&
                DIM SHARED OldDskSide&
                DIM SHARED SideLen&
                
                DIM SHARED SekTrack%
                DIM SHARED FType$
                
                
                DIM SHARED MHTB&
                DIM SHARED MHSectZero&
                DIM SHARED MHSecLen%
                DIM SHARED MHSekt256(1) AS STRING * 256
                DIM SHARED MHSekt512(1) AS STRING * 512
                DIM SHARED MHFloppy$
                DIM SHARED SubDirStAddr(0 TO 10)  AS INTEGER
                DIM SHARED SubDirName$(0 TO 10)
                DIM SHARED SectPerAU%
                DIM SHARED SourcePath$
                COMMON SHARED Endk$
		
		TYPE IDXType
		Section AS STRING * 20
		StartRec AS DOUBLE
		RecLength AS SINGLE
		END TYPE
		DIM SHARED IDXRecord AS IDXType                
                
                DIM SHARED TempArk AS STRING
                TempArk = "~ARKTMP.TMP"

                DIM SHARED DoubleBorder$    ' Double Border Box characters
                DIM SHARED SingleBorder$
                DoubleBorder$ = "ͻͼ"      ' Double Border Box characters
                SingleBorder$ = "Ŀ"      ' Single Border Box characters 
          

                NormForeColor = 7' Normal Foreground Color
                NormBackColor = 0 ' Normal Background Color
                FC = NormForeColor
                BC = NormBackColor
                
                Endk$ = CHR$(13)
                Endk$ = Endk$ + CHR$(27)
                Endk$ = Endk$ + CHR$(9)
                Endk$ = Endk$ + CHR$(0) + CHR$(72) '
                Endk$ = Endk$ + CHR$(0) + CHR$(80)
                Endk$ = Endk$ + CHR$(0) + CHR$(59) ' F1 = Help 
                Endk$ = Endk$ + CHR$(0) + CHR$(63) ' F5  Key
                Endk$ = Endk$ + CHR$(0) + CHR$(64) ' F6  Key
                Endk$ = Endk$ + CHR$(0) + CHR$(68) ' F10 Key
                
                CONST ChkPath%     = 1   ' Check if path exists.
                CONST ChkFilXist%  = 2   ' Check if path\filename exists.
                CONST ChkFilCreat% = 4   ' Check if filename can be created (i.e. if path exists and filename 
		                         ' has not the same name of an existing directory)
                Inffixed$ = "~DOSDIR.TMP"
                ReturnFile$= "~Merge.dat"
                OutFile$="~OutMrg.img"
                
                OPEN ReturnFile$ FOR INPUT AS #72
                INPUT #72, Option$
                INPUT #72, TFNames% 
                INPUT #72, CurrentFilename%
                INPUT #72, CurrentScreenRow%
                INPUT #72, FirstFilename%
                INPUT #72, TotFiles2Copy%
                INPUT #72, TotSizeFiles2Copy#
                INPUT #72, CurrDir$

IntroAgain:                
                GOSUB IntroScreen
                IF  DU$=CHR$(27) THEN CLOSE #72: GOTO MergeChain
                If  DU$=CHR$(0) + CHR$(59) THEN COLOR FC, BC: GOSUB HelpAskedFor : GOTO IntroAgain   
             
                'OutFile$=CurrDir$+OutFile$
                REDIM CopyMark$(TFNames%)
                OPEN Inffixed$ FOR RANDOM ACCESS READ WRITE AS #4 LEN = 256
                FIELD #4, 256 AS L$
                LOCATE 4,4

' FIRST OFF, CHECK ALL SOURCE FILES               
                FOR FT% = 1 TO TFNames%  'Check all files
                LINE INPUT #72,CopyMark$(FT%)
                IF CopyMark$(FT%)<>"M" THEN GOTO NotMerge
        
                GET #4,FT%
                GOSUB DOSAsmblFilXpres: IF Mystring$ = "" THEN CopyMark$(FT%)="W" : GOTO NotMerge
                ' PRINT " - "; ' Mystring$;
                CALL TxDir(Mystring$, SectZero20$, Sect1$, TotSect&,TotEr%,ErrSect$ ,ErrInFil$,ErrInFD$,"CR")
                IF TotEr%=-1 THEN CopyMark$(FT%)="X" : GOTO NotMerge
        
                
                IF OldSectZero20$="" THEN  GOTO FirstTime
                IF SectZero20$<>OldSectZero20$ THEN CopyMark$(FT%)="Y" : GOTO NotMerge
                IF Sect1$=OldSect1$ THEN GOTO NextMerge
                'Give user the chance to choose if he wants to exclude files with sector 1 not matching                 
                CopyMark$(FT%)="Z" : GOTO NotMerge
                
NextMerge:                      
FirstTime:      OldSectZero20$=SectZero20$: OldSect1$=Sect1$
                ' Set First File (Lowest error file)
                IF FrstFile%=0 THEN OldTotEr%=TotEr%: FrstFile%= FT% ELSE IF TotEr%<OldTotEr% THEN OldTotEr%=TotEr% : FrstFile%= FT%
                GoodMerge%= GoodMerge% + 1 
                
NotMerge:       
                NEXT FT%
                CLOSE #72
		FrstTotEr%= OldTotEr% ' Total sector errors in file with least sector error count
		
' SHOW FILE SCREEN                
OnceAgain:                
                GOSUB ShowList
                IF GoodMerge%<2 THEN GOSUB AtLeast2 : CLOSE #4: GOTO MergeChain ' The must be at least 2 files
                GOSUB WhatName4aFile
                GOSUB ChooseOutFile  
                IF Exitk$=CHR$(27) THEN CLOSE #4: GOTO MergeChain
                If  Exitk$=CHR$(0) + CHR$(59) THEN COLOR 7, 0: : GOSUB HelpAskedFor : GOTO OnceAgain                 	
                If ValidFullPath(OutFile$,ChkFilCreat%)<>0 Then Cls: GOTO OnceAgain
                
                IF ZerOneMM$="Y" and FrstTotEr%<>0 THEN LOCATE 18, 4: COLOR 11, 0:PRINT "Press 'P' to proceed, using even files with basic sector mismatches."
                LOCATE 19, 4: COLOR 14, 0
                PRINT "Press 'ESC' to abort, any other key to proceed normally."
                DO: DU$ = INKEY$: LOOP UNTIL DU$ <> ""
                If  DU$=CHR$(27) THEN CLOSE #4: GOTO MergeChain
                If  DU$=CHR$(0) + CHR$(59) THEN COLOR 7, 0: GOSUB HelpAskedFor :  GOTO OnceAgain 
                
                

                
                        
' OPEN MERGE OUTPUT FILE                
                OutFileHndl%=100
                OutPutFile$ =  OutFile$ 
                CALL ShortLongName(OutPutFile$, CR$, 3)' Get ShortFilename and create a long one if none exists. Return the short one anyway
                                                       
                OPEN OutPutFile$ FOR RANDOM ACCESS WRITE AS #OutFileHndl% LEN = 256 
                FIELD #OutFileHndl% , 256 AS OutDat$                    
                
                
' OPEN FIRST FILE                       
                FrstFileHandle% =101 ' First file handle will be 101
                GET #4,FrstFile%
                GOSUB DOSAsmblFilXpres
                CALL TxDir(Mystring$, FrstSectZero20$, FrstSect1$,FrstTotSect&,FrstTotEr%,FrstErrSect$ ,FrstErrInFil$,FrstErrInFD$,"ER")
                SavFrstTotEr%=FrstTotEr%
                OPEN Mystring$ FOR RANDOM ACCESS READ AS #FrstFileHandle% LEN = 256 
                FIELD #FrstFileHandle% , 256 AS FrstRecDat$
   
                
' COPY FIRST FILE (LOWEST ERROR FILE) INTO THE OUTPUT FILE
                B=0: IF FrstTotEr%<>0 THEN B=3
                FOR T%=1 TO FrstTotSect& + B
                GET #FrstFileHandle%, T%
                LSET OutDat$ = FrstRecDat$
                PUT #OutFileHndl%, T%
                NEXT T%
                CLOSE #FrstFileHandle%
                IF FrstTotEr% = 0 THEN CLOSE #OutFileHndl%: GOTO NoBadSector
                	

' OPEN OTHER FILES AND FILL IN MISSING SECTORS
' MAIN LOOP STARTS HERE
                OthFileHandle% =102 ' Other files handle will be 102
                
                FOR FT% =1 TO TFNames% 
                IF FrstTotSect&=0 THEN GOTO CloseOutFil
                IF CopyMark$(FT%)<>"M" THEN GOTO DontOpen2
                IF FT%=FrstFile% THEN GOTO DontOpen2 ' Skip lowest error file (we have already copied it)
                GET #4,FT%
                GOSUB DOSAsmblFilXpres
                CALL TxDir(Mystring$, SectZero20$, Sect1$, TotSect&,TotEr%,ErrSect$ ,ErrInFil$,ErrInFD$,"ER")

                OPEN Mystring$ FOR RANDOM ACCESS READ AS #OthFileHandle% LEN = 256 
                FIELD #OthFileHandle%, 256 AS RecDat$

' SEE WHAT SECTOR FIRST FILE NEEDS FROM THE CURRENT FILE  (FOR FT% =1 TO TFNames% )
                FOR J1% = 0 TO (FrstTotSect& / 8) - 1
                IF FrstTotSect&=0 THEN CLOSE  #OthFileHandle% : GOTO CloseOutFil
                MyBitMap$ = MID$(FrstErrSect$, 33 + J1%, 1)
                IF ASC(MyBitMap$) = 0 THEN GOTO NextByte1
                FOR W1% = 0 TO 7
                IF ASC(MyBitMap$) AND 2 ^ W1% THEN GOTO K1found ELSE GOTO NextW1
K1found:        K1% = J1% * 8 + W1%

                CALL GetOffsetMask(K1%,ByteOff%,BitMask%)
                ErrByte$ = MID$(ErrSect$, 33 + ByteOff%, 1)
                IF (ASC(ErrByte$) AND BitMask%) <> 0 THEN GOTO NextW1 ' If ASC(T$) AND BitMask%) is = 0 then Sector is Good!

                GET #OthFileHandle%,K1%+1 
   
                LSET OutDat$ = RecDat$
                PUT #OutFileHndl%,K1%+1  
 
' Adjust Total Errors
                FrstTotEr%=FrstTotEr%-1
                T$=LTRIM$(RTRIM$(STR$(FrstTotEr%)))
                'PRINT  "Updated Tot. Errors 1 =";T$
                T$=SPACE$(8-LEN(T$))+T$
                MID$(FrstErrSect$,13)=T$
                'PRINT  "Updated Tot. Errors 2 =";T$
' Adjust Error BitMap (last 3 records)          
                T= ASC(ErrByte$) AND  (255-BitMask%)
                'PRINT  "Adjust Error BitMap =";T
                MID$(FrstErrSect$,33 + ByteOff%)=CHR$(T)
                
NextW1:         NEXT W1%
NextByte1:      NEXT J1%

DontOpen:       CLOSE  #OthFileHandle%
DontOpen2:      NEXT FT%

                IF FrstTotSect&=0 THEN GOTO CloseOutFil
                FOR T=1 TO 3
                T$=MID$(FrstErrSect$,1+((T-1)*256),256)
                LSET OutDat$ = T$
                PUT #OutFileHndl%,FrstTotSect&+T
                NEXT T
                
CloseOutFil:    CLOSE #OutFileHndl%
                GOTO MergExit

' Special case: A Disk Image has no bad sectors
NoBadSector:            
                
MergExit:       
		  CALL TxDir(OutPutFile$, OutSectZero20$, OutSect1$,OutTotSect&,OutTotEr%,OutErrSect$ ,OutErrInFil$,OutErrInFD$,"ER")
                CLOSE #4 
DisplayAgain:   GOSUB DisplResults
		  DO: DU$ = INKEY$: LOOP UNTIL DU$ <> ""
                IF DU$<>CHR$(0) + CHR$(63) THEN GOTO MergeChain
                CALL TxDir(OutPutFile$, OutSectZero20$, OutSect1$,OutTotSect&,OutTotEr%,OutErrSect$ ,OutErrInFil$,OutErrInFD$,"")
                
                	
MergeChain:     CHAIN "PC-DIR05.BAS"

' Splash Screen
IntroScreen:    
                CLS
                COLOR 12, 0
                CALL box(1, 2, 78, 24,DoubleBorder$)
                LOCATE 1, 13 
                COLOR 14, 0
                PRINT " --- MERGE FILE OPTION: merge 2 or more files --- "
                COLOR 14, 0
                LOCATE  3, 4: Print  "Q: Why should I want to merge disk images?"
                LOCATE  5, 4: Print  "A: You want to merge disk images when you have different copies, each with"
                LOCATE  6, 4: Print  "sector errors, from the same TI floppy disk. Hopefully, at the end of the"
                LOCATE  7, 4: Print  "merge process, you will get a new, maybe precious, error free copy."
                        
                LOCATE  9, 4: Print  "Sector Errors, in file with errors, must be visible as F3 Errors when a TI"
                LOCATE 10, 4: Print  "Disk Catalog is called (F5 from any menu). Files with errors are those"
                LOCATE 11, 4: Print  "that have 3 extra sectors attached at the end. V9T9 or PC99 files are NOT "
                LOCATE 12, 4: Print  "files with error tables because they lack the 3 extra sectors attached to "
                LOCATE 13, 4: Print  "the end. The only disk images with with errors are those obtained from"
                LOCATE 14, 4: Print  "reading a real floppy with TI99-PC."
                
                
                LOCATE 16, 4: Print  "In each merge session, just one final new file will be created. So,"
                LOCATE 17, 4: Print  "make sure to mark (with 'M' key) only multiple copies obtained from "
                LOCATE 18, 4: Print  "the same TI floppy disk, otherwise the new file will be just junk." 
                LOCATE 20, 4: Print  "All the selected files have to be in the same directory."
                
                LOCATE 23, 10: Print  " Press ESC to abort or any other key to go on with Merging "
                LOCATE 23, 78:
                
                DO: DU$ = INKEY$: LOOP UNTIL DU$ <> ""
                RETURN 
'                
HelpAskedFor:   CALL ThisHelp("HELP - GENERAL FILE", "Manual.dat", "Manual.idx", "39.01.03") 
		  RETURN 
' Display all files on screen           
ShowList:       Cls 
                COLOR 12, 0
                Call box(1, 2, 78, 24,DoubleBorder$)
                COLOR 14, 0
                LOCATE 1, 28 
                PRINT " --- MERGE FILE OPTION --- "
                LOCATE 2, 3 
                PRINT " Files selected for merging:"
                LOCATE 24, 6:
                PRINT " Directory: " ; CurrDir$; " ";
                LOCATE 23, 13:
                ZerOneMM$="" : MrgFiles%=0
                FOR CurrentFilename%=1 TO TFNames% 
                IF CopyMark$(CurrentFilename%)=" " THEN GOTO NotMarked
                MrgFiles%=MrgFiles%+1
                
                GET #4, CurrentFilename%   
                 
                IF MrgFiles%>14 THEN LOCATE 17,3 : PRINT ".... Screen full. Next files will not be shown."; : GOTO ShowListExit
                GOSUB DOSAsmblFilXpres: IF Mystring$ = "" THEN GOTO NotMarked
                IF CurrentFilename%=FrstFile% THEN FrstFileName$ = MID$(Mystring$,LEN(CurrDir$)+1,LEN(Mystring$))
                LOCATE MrgFiles%+2, 3 : PRINT STR$(MrgFiles%); ") "; MID$(Mystring$,LEN(CurrDir$)+1,LEN(Mystring$)) ; '68
                PRINT TAB(28);  
                
                SELECT CASE   CopyMark$(CurrentFilename%)
                
                CASE "M"
                COLOR 10, 0
                IF CurrentFilename%<>FrstFile% THEN COLOR 14, 0: PRINT "* Normal Error File, good *" : GOTO ShowList22
                IF FrstTotEr%<>0 THEN PRINT "* Least Error File, good *" : GOTO ShowList22
                PRINT "* FILE WITH NO ERROR, MERGE FILE WILL BE THIS ONE *"
                CASE "W"
                COLOR 12, 0
                PRINT "- Bad Filename -"
                CASE "X" 
                COLOR 12, 0
                PRINT "- Not a TI disk image file, skipped -" 
                CASE "Y"  
                COLOR 11, 0    
                ZerOneMM$="Y"                               
                PRINT "- Sector Zero mismatch with Least Error File -"    
                CASE "Z"  
                COLOR 11, 0  
                ZerOneMM$="Y"                                 
                PRINT "- Sector 1 mismatch with Least Error File -"    
                CASE ELSE
                END SELECT
ShowList22:     COLOR 14, 0
NotMarked:      NEXT CurrentFilename%
ShowListExit:   
                RETURN          

ChooseOutFile:  COLOR 12, 0
                Call box(21, 3, 72, 3,SingleBorder$)
                COLOR 10, 0
                LOCATE 21, 6
                PRINT "Name of the new Merge file to be created:"
                OutFile$ = Xinput$(22, 6, 68, OutFile$, "", Endk$, Exitk$, RealStrLen%)
                
                RETURN 
                
' DISPLAY RESULTS ON SCREEN
DisplResults:		
		COLOR 12, 0
                Call box(18, 3, 72, 4,SingleBorder$)
                COLOR 14, 0
                LOCATE 18, 6: PRINT " - Done! - "
                LOCATE 21, 26 :COLOR 14, 0: PRINT " - Press F5 to catalog the newly created file - "
                
                LOCATE 19, 6
                SELECT CASE OutTotEr%
                CASE 0
                COLOR 10, 0
                PRINT "Good news! The new merge file has zero (0) errors."
                
                CASE ELSE
                COLOR 14, 0
                PRINT "The new merge file has still";OutTotEr%;"errors (it had";SavFrstTotEr%;"before merging)."
                IF LEN(OutErrInFil$+OutErrInFD$)=0 THEN LOCATE 20, 6 :COLOR 10, 0: PRINT "The good news is that none of the above errors affects any file!"
        	  END SELECT 
                RETURN   
                
AtLeast2:		
		COLOR 12, 0
                Call box(18, 3, 72, 3,SingleBorder$)
                'COLOR 14, 0
                LOCATE 19, 8 : PRINT "- At least 2 good files are needed. Exit and try again -"
                WHILE INKEY$ = "": WEND
                RETURN                              
                
WhatName4aFile: 
		'FrstFileName$
		'CurrDir$
		A=INSTR(FrstFileName$,".")
		IF A=0 THEN A$=FrstFileName$ : B=LEN(FrstFileName$):B$="" ELSE B=A-1: A$=LEFT$(FrstFileName$,B):B$=RIGHT$(FrstFileName$,LEN(FrstFileName$)-B)

		SELECT CASE B
		
		CASE <=5
		A$=A$+"Mrg"

		CASE <=8
		MID$(A$,LEN(A$))="Mrg"
		
		CASE ELSE 
		A$=A$+"Mrg"
		END SELECT
		
		OutFile$=CurrDir$+A$+B$
                RETURN

DEFINT A-Z

' TI-Dir has the return program name stored in MyName$(11).  MyName$(11) is devoted exclusively to TI-Dir usage.
' TI-Dir has the Disk image filename on which it will work upon stored in MyName$(12).  MyName$(11) is devoted exclusively to TI-Dir usage.
SUB TxDir (TxDDosFile$, TxDSectZero20$, TxDSect1$, TxDTotSect&,TxDTotEr%,TxDErrSect$ ,TxDErrInFile$,TxDErrInFDR$,TxDMode$)
' IF TxDTotEr%=-1 then TxDDosFile$ is not a valid TI Disk Image file
' TxDTotSec% = Total Sectors (360,729,1440,2880...)
' TxDTotEr% = Total Sectro Errors
' TxDBitMapEr$ = BitMap of sector errors. Each bit is one sector
' TxDErrInFile$ = Error Sector in Files (sector erro in FDR are not counted here). 2 bytes for each sector (MSByte + LSByte)
' TxDErrInFDR$ = Error Sector in FDR (File Descriptor Record, the sector where Filename and all sectors that belong 
'               to that filename are stored) - 2 bytes for each sector (MSByte + LSByte)
' TxDMode$="ER" Error Report in Parameters, no display of any type
' TxDMode$="CR" Content Report in Parameters (Total Sectors, no display of any type

TxDFileNum% = 58   ' 1
TxDNormForeColor = 10' Normal Foreground Color
TxDNormBackColor = 0 ' Normal Background Color
FC = TxDNormForeColor
BC = TxDNormBackColor
HFC = 15         ' Higlighted Foreground Color
HBC = 10         ' Higlighted Background Color

                
                
                IF TxDMode$="" THEN CLS
                COLOR FC, BC
                TxDSourcePath$ = TxDDosFile$
                REDIM FilName$(1)
                'PB 2008.8.6 - FOR T = LEN(TxDDestinPath$) TO 1 STEP -1
                'PB 2008.8.6 - IF MID$(TxDDestinPath$, T, 1) = "\" THEN GOTO TxDBackFound
                'PB 2008.8.6 - NEXT T
                'PB 2008.8.6 - TxDPath$ = TxDDestinPath$
                'PB 2008.8.6 - GOTO TxDBackFound2
'PB 2008.8.6 - TxDBackFound:
                'PB 2008.8.6 - TxDPath$ = LEFT$(TxDDestinPath$, T)
'PB 2008.8.6 - TxDBackFound2:
                GOTO TxDOpenFile

' 
TxDAbort:       TxDTotEr%=-1 
                GOTO TxDLeaveit2
                
' Exit point with F9
TxDLeaveit:     'MyName$(12) = TxDSourcePath$
TxDLeaveit2:    ERASE FilName$
                CLOSE #TxDFileNum%
                COLOR 7, 0
                GOTO TxDirExit
                ' IF MyName$(11) = "" THEN CLS : END ELSE CHAIN MyName$(11)

TxDOpenFile:    CALL ShortLongName(TxDSourcePath$,CR$,1) ' Get Short Name out of a long filename
                IF TxDMode$="ER" THEN TxDDosFile$= TxDSourcePath$  ' PB 2008.08.07 - Report Error sector 
                TxDSrcDOSName$ = TxDSourcePath$
                OPEN TxDSrcDOSName$ FOR BINARY ACCESS READ AS #TxDFileNum%
                ON ERROR GOTO 0
                
                CALL GetVirtualZero(TxDFileNum%, d$)
                TxDDskName$ = MID$(d$, 1, 10)
                MHFloppy$ = MID$(d$, 14, 3)
                TxDSectZero20$=MID$(d$, 1, 20)  ' PB 2008.08.07 - Report Error sector 
                
                IF FType$ <> "MH" THEN GOTO TxDPOI
                'CALL MessHDDir(TxDFileNum%, d$)
                GOTO TxDAbort
TxDPOI:
                IF MHFloppy$ = "DSK" OR FType$ = "MH" THEN GOTO TxDIdentFound
                IF TxDMode$<>"" THEN GOTO TxDAbort ' PB 2008.08.07 - Report Error sector or Content Report
                CALL box(1, 4, 72, 10,DoubleBorder$)
                LOCATE 2, 6, 1
                PRINT "TI-99/4A DiskName: "; TxDDskName$;
                LOCATE 4, 6, 1
                PRINT "Warning....";
                LOCATE 5, 6, 1
                PRINT "This file doesn't appear to be a true TI99/Geneve Disk Image File";
                LOCATE 6, 6, 1
                PRINT "('DSK' or 'WIN' missing in sector 0).";
                LOCATE 8, 6, 1
                PRINT "Do you still want to go on? (Y/N)";
                LOCATE 8, 40, 1
                DO: C$ = INKEY$: LOOP UNTIL C$ <> ""
                IF UCASE$(C$) = "Y" THEN GOTO TxDIdentFound ELSE GOTO TxDAbort
                
TxDIdentFound:
                TxDTotSect& = CalcWord&(d$, 11)
                KSectAU% = -1 * (INT((-TxDTotSect& / 1600)))
                TxDTracks% = ASC(MID$(d$, 18, 1))
                TxDSides% = ASC(MID$(d$, 19, 1)): IF TxDSides% = 0 THEN TxDSides% = 1
                TxDDens% = ASC(MID$(d$, 20, 1)): IF TxDDens% = 0 THEN TxDDens% = 1
                
                SELECT CASE LEFT$(FType$, 1)
                CASE "V"
                DiskType$ = "V9T9"
                CASE "P"
                DiskType$ = "PC99"
                CASE ELSE
                DiskType$ = "TI99-PC"
                END SELECT
                
                TxDSideDensity$ = "(" + MID$("SD", TxDSides%, 1) + "S/" + MID$("SDH", TxDDens%, 1) + "D)"
                IF TxDTracks = 80 AND TxDDens% = 2 THEN MID$(TxDSideDensity$, 5, 1) = "Q"
                
                TxDCurrFileDescrIndex& = 1                        ' Sector containing the File Descriptor Index
                IF TxDTracks < 80 THEN GOTO TxDNoSubDirExist           ' Only 80 track Geneve disks can have sudirectories
                TxDChosenDir% = 1                                 ' Array element that is the Chosen Directory
                TxDActiveDirs% = 0
                FOR T = 1 TO 3
                W = CalcWord&(d$, 31 + (12 * (T - 1)))
                IF W = 0 THEN GOTO NextSubDir
                IF T = 1 THEN SubDirStAddr(1) = 1: SubDirName$(1) = "Root_Dir": TxDActiveDirs% = TxDActiveDirs% + 1
                TxDActiveDirs% = TxDActiveDirs% + 1
                SubDirStAddr(TxDActiveDirs%) = W: SubDirName$(TxDActiveDirs%) = MID$(d$, 21 + (12 * (T - 1)), 10)
NextSubDir:     NEXT T

TxDNoSubDirExist:
                TxDErrSect$ = ""
                IF LEFT$(FType$, 1) <> "V" THEN GOTO TxDNoSubDirPoss
                CALL GetVirtualSect(TxDFileNum%, TxDTotSect& + 1, d$)
                TxDErrSect$ = d$
                CALL GetVirtualSect(TxDFileNum%, TxDTotSect& + 2, d$)
                TxDErrSect$ = TxDErrSect$ + d$
                CALL GetVirtualSect(TxDFileNum%, TxDTotSect& + 3, d$)
                TxDErrSect$ = TxDErrSect$ + d$
                TxDTotEr% = VAL(MID$(TxDErrSect$, 13, 8))
TxDNoSubDirPoss:
                'PB 2008.8.6 - TxDFirstDestinPath$ = TxDDestinPath$ ' New Output Filename (just the name, nothing on disk!)
TxDNewSubDir:
                CALL GetVirtualSect(TxDFileNum%, TxDCurrFileDescrIndex& + 1, d$) ' Get Sector 1: Filename Table, alphabetically ordered
                IF TxDMode$="CR" THEN TxDSect1$=d$ ' PB 2008.08.07 - Report Error sector 
                TxDTFNames% = 1           ' We have to work out how many filenames there are
TxDNextEl:      sn% = CalcWord&(d$, (TxDTFNames%) * 2 - 1)
                IF sn% <> 0 THEN TxDTFNames% = TxDTFNames% + 1: GOTO TxDNextEl
                TxDTFNames% = TxDTFNames% - 1 + TxDActiveDirs%  ' Well this is how many filenames we've got
                IF TxDMode$<>"CR" THEN GOTO TxDNextEl2 ' PB 2008.08.07 - Content Report? 
                
                GOTO TxDLeaveit ' PB 2008.08.07 - Report Error sector 
TxDNextEl2:                     
                REDIM FilName$(TxDTFNames%)   ' DIM exactly our arrays
                REDIM StartSect&(TxDTFNames%)
                REDIM CopyMark$(TxDTFNames%)
                REDIM TxDFileErrList$(TxDTFNames%)

                FOR T = 1 TO TxDTFNames%    ' Assume users doesn't want to Extract any file
                CopyMark$(T) = " "
                IF TxDActiveDirs% > 0 AND T = TxDChosenDir% THEN CopyMark$(T) = ">"
                NEXT T
                
                FOR T = 1 TO TxDActiveDirs%    ' If Active Directories exist
                FilName$(T) = SubDirName$(T)
                StartSect&(T) = SubDirStAddr(T)
                NEXT T
                
                FOR T = TxDActiveDirs% + 1 TO TxDTFNames% ' Memorize Starting Sector of all filenames
                StartSect&(T) = CalcWord&(d$, (T - TxDActiveDirs%) * 2 - 1)
                NEXT T
                
                TxDTotSectorFiles& = 0
                ' Get all Filenames with vital parameters
                FOR T% = TxDActiveDirs% + 1 TO TxDTFNames%
                CALL GetVirtualSect(TxDFileNum%, StartSect&(T%) + 1, d$)
                FilName$(T%) = MID$(d$, 1, 20)
                
                IF CalcWord&(FilName$(T%), 15) > 32767 THEN GOTO TxDNextTotal   ' PB 2004.06.05 - Handle FDR Error (BABA)
                TxDTotSectorFiles& = TxDTotSectorFiles& + CalcWord&(FilName$(T%), 15)
TxDNextTotal:   NEXT T%
                
                ' CALL ShowHex(TxDErrSect$)
                ' Work out which file has error, if any
                IF TxDTotEr% = 0 THEN GOTO TxDNoBadSector
                FOR J = 0 TO (TxDTotSect& / 8) - 1
                T$ = MID$(TxDErrSect$, 33 + J, 1)
                IF ASC(T$) = 0 THEN GOTO TxDNextByte
                FOR W = 0 TO 7
                IF ASC(T$) AND 2 ^ W THEN K = J * 8 + W: GOSUB TxDWorkOutWhichFile
                NEXT W
TxDNextByte:    NEXT J
                
TxDNoBadSector: IF TxDMode$="ER" THEN GOTO TxDLeaveit ' PB 2008.08.07 - Report Error sector 
        
                ' Prepare to show all filenames
                
                TxDCurScreenRow% = 1
                TxDTotalScreenRows% = 13     ' Rows to display Filenames
                TxDStartRow% = 7  ' Screen Start Row
                TxDCurFilename% = 1
                TxDTotFiles2Copy% = 0
                TxDTotSizeFiles2Copy& = 0                         ' Added on August 27, 2003 from a tip of Ben Yates. Thank you, Ben!
                TxDAllowedKey$ = CHR$(27)                         ' ESC
                TxDAllowedKey$ = TxDAllowedKey$ + CHR$(0) + CHR$(72) ' Arrow Up
                TxDAllowedKey$ = TxDAllowedKey$ + CHR$(0) + CHR$(80) ' Arrow Down
                TxDAllowedKey$ = TxDAllowedKey$ + CHR$(0) + CHR$(73) ' Page Up
                TxDAllowedKey$ = TxDAllowedKey$ + CHR$(0) + CHR$(81) ' Page Down
                TxDAllowedKey$ = TxDAllowedKey$ + CHR$(0) + CHR$(83) ' Del
                TxDAllowedKey$ = TxDAllowedKey$ + CHR$(0) + CHR$(71) ' Home
                TxDAllowedKey$ = TxDAllowedKey$ + CHR$(0) + CHR$(79) ' End
                TxDAllowedKey$ = TxDAllowedKey$ + CHR$(0) + CHR$(59) ' F1 = Help
                TxDAllowedKey$ = TxDAllowedKey$ + CHR$(0) + CHR$(61) ' F3 = Show Bad Sector
                TxDAllowedKey$ = TxDAllowedKey$ + CHR$(0) + CHR$(65) ' F7 = Show Bad Sector
                TxDAllowedKey$ = TxDAllowedKey$ + CHR$(0) + CHR$(66) ' F8 = Show ARK file directory, if applicable
                TxDAllowedKey$ = TxDAllowedKey$ + CHR$(21)           ' CTRL U = Unmark All
                TxDAllowedKey$ = TxDAllowedKey$ + CHR$(1)            ' CTRL A = Copy All
                TxDAllowedKey$ = TxDAllowedKey$ + CHR$(3)            ' CTRL C
                TxDAllowedKey$ = TxDAllowedKey$ + CHR$(13)           ' Enter = Execute
                TxDAllowedKey$ = TxDAllowedKey$ + "CcMm1234567890 "            ' CcMmXx + Blank +1234567890
                
                GOSUB TxDTopScreen ' Display Top Part of Title Screen
                'GOSUB DispMem
                IF TxDTFNames% = 0 THEN GOSUB TxDAbsNoFiles: GOTO TxDLeaveit

'===================================
' DISK CATALOG MAIN LOOP STARTS HERE
'===================================

TxDNextFileName:
                COLOR FC, BC
                
                IF TxDCurScreenRow% = 1 THEN TxDFirstFilename% = TxDCurFilename%   ' Get Number of first filename only
                GOSUB TxDDisplayRow  ' Display Current Row

                TxDCurFilename% = TxDCurFilename% + 1 ' Next Filename


                TxDLastScreenRow% = TxDCurScreenRow%      ' Save last Screen Row used
                TxDCurScreenRow% = TxDCurScreenRow% + 1  ' Next Screen Row
                IF TxDCurScreenRow% < TxDTotalScreenRows% + 1 AND TxDCurFilename% <= TxDTFNames% THEN GOTO TxDNextFileName

'===================================
' DISK CATALOG MAIN LOOP ENDS HERE
'===================================
'
' End of filenames
                GOSUB TxDBottomLine       ' Display Bottom Line
                TxDLastFilename% = TxDCurFilename% - 1' Get Number of Last used filename
                TxDCurFilename% = TxDFirstFilename%  ' Current filename is now first filename in screen

                TxDCurScreenRow% = 1
                IF TxDKeepCursBottom% = 0 THEN GOTO TxDLocateCursor2
                ' Last key used was Arrow Down. Move Cursor and TxDFileNumber pointer to last filename in Screen
                TxDCurScreenRow% = TxDTotalScreenRows%: TxDKeepCursBottom% = 0: TxDCurFilename% = TxDLastFilename%
                GOTO TxDLocateCursor2
                
TxDLocateCursor:
                GOSUB TxDRestoreColor

TxDLocateCursor2:
                LOCATE TxDStartRow% + TxDCurScreenRow%, 2, 1
                COLOR HFC, HBC: GOSUB TxDDisplayRow: COLOR FC, BC' Display Current Row
                LOCATE TxDStartRow% + TxDCurScreenRow%, 2, 1
                TxDOldScreenRow% = TxDCurScreenRow%
                TxDOldFilename% = TxDCurFilename%
                IF TxDGoToThisDir% <> 0 THEN TxDCurFilename% = TxDGoToThisDir%: TxDGoToThisDir% = 0: GOTO TxDExecutit
                'GOSUB ShowValues    ' My little Debugger
                
TxDDoitAgain:   DO: U$ = INKEY$: LOOP UNTIL U$ <> ""
                IF INSTR(TxDAllowedKey$, U$) = 0 THEN GOTO TxDDoitAgain

                ' ESCape Key
                IF U$ = CHR$(27) THEN GOTO TxDLeaveit2
                ' ENTER Key
                IF U$ <> CHR$(13) THEN GOTO TxDIsArrowDown
                IF TxDTotEr% > 0 AND TxDFileErrList$(TxDCurFilename%) <> "" THEN GOTO TxDOtherKey9B
                IF TxDCurFilename% > TxDActiveDirs% THEN GOTO TxDStartCopying
                IF TxDCurFilename% = TxDChosenDir% THEN GOTO TxDStartCopying
                IF TxDTotFiles2Copy% = 0 THEN GOTO TxDChangeDir
                
TxDChangeDir:      TxDChosenDir% = TxDCurFilename%
                TxDGoToThisDir% = TxDCurFilename%
                TxDCurrFileDescrIndex& = SubDirStAddr(TxDCurFilename%)
                CALL Fischio
                GOTO TxDNewSubDir

TxDIsArrowDown:    ' Arrow Down Key
                IF U$ <> CHR$(0) + CHR$(80) THEN GOTO TxDOtherKey0
TxDIsArrowDown1:   IF TxDCurScreenRow% < TxDLastScreenRow% THEN TxDCurScreenRow% = TxDCurScreenRow% + 1: TxDCurFilename% = TxDCurFilename% + 1: GOTO TxDLocateCursor
                IF TxDCurFilename% = TxDTFNames% THEN GOTO TxDLocateCursor
                TxDCurFilename% = TxDFirstFilename% + 1
                TxDKeepCursBottom% = 1
                IF TxDCurFilename% < 1 THEN TxDCurFilename% = 1
                GOTO TxDExecutit

TxDOtherKey0:        'Arrow up Key
                IF U$ <> CHR$(0) + CHR$(72) THEN GOTO TxDOtherKey1
                IF TxDCurFilename% = 1 THEN GOTO TxDNoMatch
                IF TxDCurScreenRow% > 1 THEN TxDCurScreenRow% = TxDCurScreenRow% - 1: TxDCurFilename% = TxDCurFilename% - 1: GOTO TxDLocateCursor
                TxDCurFilename% = TxDFirstFilename% - 1: IF TxDCurFilename% < 1 THEN TxDCurFilename% = 1
                GOTO TxDExecutit

TxDOtherKey1:        ' Page Up Key
                IF U$ <> CHR$(0) + CHR$(73) THEN GOTO TxDOtherKey2
                TxDCurFilename% = TxDFirstFilename% - TxDTotalScreenRows%
                IF TxDCurFilename% < 1 THEN TxDCurFilename% = 1
                GOTO TxDExecutit

TxDOtherKey2:        ' Page Down Key
                IF U$ <> CHR$(0) + CHR$(81) THEN GOTO TxDOtherKey4
                IF TxDLastFilename% + 1 + TxDTotalScreenRows% > TxDTFNames% THEN TxDCurFilename% = TxDTFNames% - TxDTotalScreenRows% + 1: IF TxDCurFilename% < 1 THEN TxDCurFilename% = 1: GOTO TxDExecutit
                TxDCurFilename% = TxDFirstFilename% + TxDTotalScreenRows%
                IF TxDCurFilename% > TxDTFNames% THEN TxDCurFilename% = TxDFirstFilename%
                GOTO TxDExecutit

TxDOtherKey4:      ' C or c, M or m
                IF U$ <> "c" AND U$ <> "C" AND U$ <> "M" AND U$ <> "m" THEN GOTO TxDOtherKey5
                IF TxDCurFilename% <= TxDActiveDirs% THEN CALL ERRSOUND: GOTO TxDNoMatch
                IF CopyMark$(TxDCurFilename%) = " " THEN TxDTotFiles2Copy% = TxDTotFiles2Copy% + 1: GOSUB TxDSectorLength: TxDTotSizeFiles2Copy& = TxDTotSizeFiles2Copy& + TxDSectorLength&
                LOCATE TxDStartRow% + TxDCurScreenRow%, 2, 1
                COLOR HFC, HBC
                CopyMark$(TxDCurFilename%) = "C": PRINT "C";
                GOSUB TxDDispFilestoCopy
                GOTO TxDIsArrowDown1
                
TxDOtherKey5:      ' CTRL U = Unmark all
                IF U$ <> CHR$(21) THEN GOTO TxDOtherKey6
                FOR T = TxDActiveDirs% + 1 TO TxDTFNames%  ' Assume users wants to Copy all files
                CopyMark$(T) = " "
                NEXT T

                TxDTotFiles2Copy% = 0
                TxDTotSizeFiles2Copy& = 0
                GOSUB TxDRePaintScreen
                GOTO TxDNoMatch

TxDOtherKey6:      ' CTRL A = Mark all
                IF U$ <> CHR$(1) AND U$ <> CHR$(3) THEN GOTO TxDOtherKey7
                FOR T = TxDActiveDirs% + 1 TO TxDTFNames%  ' Assume users wants to Copy all files
                IF CopyMark$(T) = " " THEN CopyMark$(T) = "C"
                NEXT T
                
                TxDTotFiles2Copy% = TxDTFNames%
                TxDTotSizeFiles2Copy& = TxDTotSectorFiles&
                GOSUB TxDRePaintScreen
                GOTO TxDNoMatch
                
TxDOtherKey7:        ' Home Key : simply move cursor to top
                IF U$ <> CHR$(0) + CHR$(71) THEN GOTO TxDOtherKey8
                TxDCurScreenRow% = 1: TxDCurFilename% = TxDFirstFilename%: GOTO TxDLocateCursor


TxDOtherKey8:   ' End Key : simply move cursor to bottom
                IF U$ <> CHR$(0) + CHR$(79) THEN GOTO TxDOtherKey9
                TxDCurScreenRow% = TxDLastScreenRow%: TxDCurFilename% = TxDLastFilename%
                GOTO TxDLocateCursor

TxDOtherKey9:   ' F3 = Show Error List
                IF U$ <> CHR$(0) + CHR$(61) THEN GOTO TxDOtherKey10
                IF TxDTotEr% = 0 OR TxDFileErrList$(TxDCurFilename%) = "" THEN GOTO TxDNoMatch
TxDOtherKey9B:  GOSUB TxDShowErrorList
                GOSUB TxDRePaintScreen
                GOTO TxDNoMatch
                
                

TxDOtherKey10:  ' F7 = Show Sector as Hex
                IF U$ <> CHR$(0) + CHR$(65) THEN GOTO TxDOtherKey11
                IF TxDCurFilename% <= TxDActiveDirs% THEN GOTO TxDNoMatch
                GOSUB TxDShowSector
                GOSUB TxDRePaintScreen
                GOTO TxDNoMatch

TxDOtherKey11:  ' 0-9 priority while copying
                IF U$ < "0" OR U$ > "9" THEN GOTO TxDOtherKey12
                IF TxDCurFilename% <= TxDActiveDirs% THEN CALL ERRSOUND: GOTO TxDNoMatch
                IF CopyMark$(TxDCurFilename%) = " " THEN
                TxDTotFiles2Copy% = TxDTotFiles2Copy% + 1
                GOSUB TxDSectorLength
                TxDTotSizeFiles2Copy& = TxDTotSizeFiles2Copy& + TxDSectorLength&
                END IF
                CopyMark$(TxDCurFilename%) = U$
                LOCATE TxDStartRow% + TxDCurScreenRow%, 2, 1
                COLOR HFC, HBC
                PRINT CopyMark$(TxDCurFilename%);
                GOSUB TxDDispFilestoCopy
                GOTO TxDIsArrowDown1
                
                
TxDOtherKey12:  ' DEL key
                IF U$ <> " " AND U$ <> CHR$(0) + CHR$(83) THEN GOTO TxDOtherKey13
                IF TxDCurFilename% <= TxDActiveDirs% THEN CALL ERRSOUND: GOTO TxDNoMatch
                IF CopyMark$(TxDCurFilename%) <> " " THEN TxDTotFiles2Copy% = TxDTotFiles2Copy% - 1: GOSUB TxDSectorLength: TxDTotSizeFiles2Copy& = TxDTotSizeFiles2Copy& - TxDSectorLength&
                CopyMark$(TxDCurFilename%) = " "
                LOCATE TxDStartRow% + TxDCurScreenRow%, 2, 1
                COLOR HFC, HBC
                PRINT CopyMark$(TxDCurFilename%);
                GOSUB TxDDispFilestoCopy
                GOTO TxDIsArrowDown1
'========SHOW ARK FILE
TxDOtherKey13:  IF U$ <> CHR$(0) + CHR$(66) THEN GOTO TxDOtherKey14     ' F8 = I ARK file, display it
                IF TxDCurFilename% <= TxDActiveDirs% THEN GOTO TxDNoMatch
                
                IF ASC(MID$(FilName$(TxDCurFilename%), 18, 1)) <> 128 THEN GOTO TxDNoMatch
                FileType% = ASC(MID$(FilName$(TxDCurFilename%), 13, 1))
                FileType% = FileType% AND &H8B
                FileType% = FileType% AND &HF7
                SELECT CASE FileType%
                CASE 0, 2 ' "Dis/Fix"
                GOSUB TxDARKextract
                CLS
                COLOR HFC, HBC
                
                PRINT TAB(15); "Catalog of Archive File: "; MID$(FilName$(TxDCurFilename%), 1, 10)
                Exec$ = "Decomp4.com " + TempArk + " /s"
                SHELL Exec$
                COLOR FC, BC
                CLS
                END SELECT
                
                GOSUB TxDRePaintScreen
                GOTO TxDNoMatch
                
                
                
TxDOtherKey14:  ' F1 (Help) key
                IF U$ <> CHR$(0) + CHR$(59) THEN GOTO TxDOtherKey15
                CALL ThisHelp("HELP - GENERAL FILE", "Manual.dat", "Manual.idx", "39.01.03")
                GOSUB TxDRePaintScreen
                GOTO TxDLocateCursor


TxDOtherKey15:
                GOTO TxDNoMatch
                
TxDExecutit:
                TxDCurScreenRow% = 1     ' Cursor on first screen row
                LOCATE TxDStartRow% + TxDCurScreenRow%, 2, 1
                GOTO TxDNextFileName   ' Start next round

TxDStartCopying:
TxDNoMatch:     GOTO TxDLocateCursor

                '=================================
' DISPLAY TOP PART OF TITLE SCREEN
'=================================
TxDTopScreen:
                LOCATE 1, 3, 1
                PRINT "TI DISK CATALOG FROM F5 KEY - NO SELECTION, NO ACTION, JUST TO VIEW FILE NAMES"
                LOCATE 2, 1
                PRINT "TI-99/4A DiskName:"; TxDDskName$; "    Sectors:"; TxDTotSect&; " TxDTracks:"; TxDTracks%; " TxDSides:"; TxDSides%; " TxDDens:"; TxDDens%;
                LOCATE 3, 1
                PRINT DiskType$; " Source File= "; TxDSourcePath$;
                PRINT TAB(60); "Files="; TxDTFNames%;
                PRINT TAB(71); TxDSideDensity$
                LOCATE 4, 1
                
                PRINT "Disk Image File type = "; DiskType$; TAB(60); "Used:"; TAB(71); "Bad:"; TxDTotEr%
                LOCATE 4, 65
                PRINT TxDTotSectorFiles&
                LOCATE 5, 1
                PRINT "Ŀ"
                PRINT "  n. Filename  P TSect Length  Type           Select:      Sectors:        "
                PRINT "Ĵ"
                GOSUB TxDDispFilestoCopy
                IF TxDTotEr% = 0 THEN GOTO IfSomeFileName
                LOCATE 6, 51
                PRINT "- Bad Sectors Full List = F3";
                
IfSomeFileName:
                LOCATE 23, 1
                'PRINT "Enter=Execute. C,M=Select, CTRL A=Select All, CTRL U=UnSel.All, 0=Served first,"
                PRINT "ESC=Exit, Cursor=ArrUp,Dwn,PagUp,Dwn. F1=Help. F7= File Hex Sector Viewer."
                LOCATE 24, 1
                'PRINT "1-9=Next to be served, C=Last to be served. Cursor=ArrUp,Dwn,PagUp,Dwn. "

                PRINT TAB(30); "F8= Cat ARK File.";
                RETURN

'==========================
' DISPLAY CURRENT ROW
'==========================
TxDDisplayRow:
                LOCATE TxDStartRow% + TxDCurScreenRow%, 1, 1
                'PRINT "                                                                              "
                PRINT ""; CopyMark$(TxDCurFilename%); "";
                PRINT USING "###"; TxDCurFilename%;
                PRINT ""; MID$(FilName$(TxDCurFilename%), 1, 10);
                
                'IF MID$(FilName$(TxDCurrentFilename%), 1, 10) = STRING$(10, CHR$(&HBA)) THEN GOTO TxDBadSectorList'' PB 2004.06.05 - Handle FDR Error (BABA) -
                IF MID$(FilName$(TxDCurFilename%), 1, 10) = STRING$(10, CHR$(&HBA)) THEN PRINT TAB(19); "_ BAD FDR "; :GOTO TxDBadSectorList'' PB 2008.08.10 - TiDCurFilename% (NOT TiDCurrentFilename%)
                IF TxDCurFilename% > TxDActiveDirs% THEN GOTO TxDNoSubDirs
                IF TxDCurFilename% = TxDChosenDir% THEN PRINT TAB(19); "< Active Dir >";
                PRINT TAB(34); ".. <Dir>.."; TAB(49); "";
                GOTO NoTxDErrSectInFile
TxDNoSubDirs:

                FileType% = ASC(MID$(FilName$(TxDCurFilename%), 13, 1))
                FileType% = FileType% AND &H8B         ' Get rid of reserved bits: 2,4-6
                IF FileType% AND 8 THEN TxDFileProt$ = "P" ELSE TxDFileProt$ = "_"
                FileType% = FileType% AND 247

                SELECT CASE FileType%
                CASE 0
                FileType$ = "Dis/Fix"
                CASE 1
                FileType$ = "Program"
                CASE 2
                FileType$ = "Int/Fix"
                CASE 128
                FileType$ = "Dis/Var"
                CASE 130
                FileType$ = "Int/Var"
                CASE ELSE
                FileType$ = "unknown"
                END SELECT


                TxDSectorLength& = CalcWord&(FilName$(TxDCurFilename%), 15) + 1
                TxDEOFTxDOffset% = ASC(MID$(FilName$(TxDCurFilename%), 17, 1))
                TxDFileLength& = TxDSectorLength& - 1
                TxDFileLength& = TxDFileLength& * MHSecLen%
                IF FileType% < 128 THEN TxDFileLength& = TxDFileLength& - 256 + TxDEOFTxDOffset%
                TxDLogRecLength% = ASC(MID$(FilName$(TxDCurFilename%), 18, 1))

                ' PRINT TxDEOFTxDOffset%;
                PRINT " "; TxDFileProt$;
                PRINT USING "####"; TxDSectorLength&;
                PRINT USING "#########"; TxDFileLength&;
                PRINT " "; FileType$;
                IF TxDLogRecLength% > 0 THEN PRINT USING "####"; TxDLogRecLength%;

                LOCATE TxDStartRow% + TxDCurScreenRow%, , 1
TxDBadSectorList:
                PRINT TAB(49); "";
                IF TxDFileErrList$(TxDCurFilename%) = "" THEN GOTO NoTxDErrSectInFile
                

                PRINT TAB(50); "Err=";
                FOR J = 1 TO LEN(TxDFileErrList$(TxDCurFilename%)) STEP 2
                IF J > 8 THEN PRINT ",..."; : GOTO NoTxDErrSectInFile
                K = CalcWord&(TxDFileErrList$(TxDCurFilename%), J)
                IF J > 1 THEN PRINT ",";
                PRINT RTRIM$(LTRIM$(STR$(K)));
                NEXT J
                
NoTxDErrSectInFile:
                
                PRINT TAB(80); "";
                RETURN
'====================
' DISPLAY BOTTOM LINE
'====================
TxDBottomLine:
                PRINT
                PRINT ""
                
                LOCATE TxDStartRow% + TxDCurScreenRow% + 1, 1, 1

                IF TxDCurScreenRow% > TxDTotalScreenRows% THEN GOTO DOSSkipClear ' Blank all unused screen rows, if any

                FOR V = TxDCurScreenRow% TO TxDTotalScreenRows%
                PRINT "                                                                                "
                NEXT V
DOSSkipClear:
                RETURN

'=========================
' REDRAW THE ENTIRE SCREEN
'=========================
TxDRePaintScreen:

                GOSUB TxDTopScreen ' Display Top Part of Title Screen
                TxDSaveCurrFilename% = TxDCurFilename%
                TxDSavCurrScreenRow% = TxDCurScreenRow%
                TxDCurFilename% = TxDFirstFilename%
                FOR TxDCurScreenRow% = 1 TO TxDTotalScreenRows%
                GOSUB TxDDisplayRow  ' Display Current Row
                TxDCurFilename% = TxDCurFilename% + 1 ' Next Filename
                TxDLastScreenRow% = TxDCurScreenRow%      ' Save last Screen Row used
                IF TxDCurFilename% > TxDTFNames% THEN TxDCurScreenRow% = TxDCurScreenRow% + 1: GOTO TxDRePaintScreen2
                NEXT TxDCurScreenRow%   ' Next Screen Row
TxDRePaintScreen2:
                GOSUB TxDBottomLine        ' Display Bottom Line
                TxDCurFilename% = TxDSaveCurrFilename%
                TxDCurScreenRow% = TxDSavCurrScreenRow%
                RETURN


TxDRestoreColor: TxDTempScreenRow% = TxDCurScreenRow%
                TempFilename% = TxDCurFilename%
                TxDCurScreenRow% = TxDOldScreenRow%
                TxDCurFilename% = TxDOldFilename%
                COLOR FC, BC: GOSUB TxDDisplayRow' Display Current Row
                TxDCurScreenRow% = TxDTempScreenRow%
                TxDCurFilename% = TempFilename%
                RETURN


TxDDispFilestoCopy: ' Display total files to be copied
                'LOCATE 4, 72, 1
                'PRINT TxDTotFiles2Copy%; "  ";
                RETURN


'=====================================
' Work out which file has a bad sector
' ====================================
TxDWorkOutWhichFile:
                K$ = STRING$(256, &HBA)                 ' PB 2004.06.05 - Handle FDR Error (BABA) -
                FOR TxDFileToCopy% = 1 TO TxDTFNames%
                CALL GetVirtualSect(TxDFileNum%, StartSect&(TxDFileToCopy%) + 1, d$)
                TxDFHeader$ = d$
                'IF TxDFHeader$ = K$ THEN K = StartSect&(TxDFileToCopy%): GOSUB TxDMarkErrFileIF: GOTO TxDWorkOutNext ' PB 2004.06.05 - Handle FDR Error (BABA) -
                IF TxDFHeader$ <> K$ THEN GOTO TxDWOutWFile2  ' PB 2008.08.10 - Handle FDR Error (BABA) -            
                IF (J*8+W) <> StartSect&(TxDFileToCopy%) THEN  GOTO TxDWorkOutNext ' PB 2008.08.10 - Handle FDR Error (BABA) -
                K = StartSect&(TxDFileToCopy%): GOSUB TxDMarkErrFileIF  ' PB 2008.08.10 - Handle FDR Error (BABA) -
                
                GOTO TxDWorkOutEnd ' PB 2008.08.10 - Handle FDR Error (BABA) - 
TxDWOutWFile2:  
                TxDSectorCnt& = CalcWord&(TxDFHeader$, 15)
                TxDOldOffs& = 0
                Z = 0
                
TxDNextChain:   IF Z > 227 THEN K = StartSect&(TxDFileToCopy%): GOSUB TxDMarkErrFileIF: GOTO TxDWorkOutNext   ' PB 2004.06.05 - Handle FDR Error (BABA) -       
                GOSUB TxDCalcClusters
                TxDCurrOffs& = TxDOffs& - TxDOldOffs&
                IF TxDStSec& = 0 THEN GOTO TxDWorkOutNext
                IF K >= TxDStSec& AND K <= TxDStSec& + TxDCurrOffs& THEN GOSUB TxDMarkErrFile: GOTO TxDWorkOutEnd
                TxDOldOffs& = TxDOffs&
                Z = Z + 3: GOTO TxDNextChain
TxDWorkOutNext:       
                NEXT TxDFileToCopy%
TxDWorkOutEnd:
                RETURN

TxDAbsNoFiles:
                PRINT ""
                A = 10
                CALL box(A, 18, 50, 8,DoubleBorder$)
                LOCATE A + 2, 24: PRINT "THIS DISK, "; TxDSourcePath$; " IS EMPTY. "
                LOCATE A + 3, 24: PRINT ""
                LOCATE A + 4, 30: PRINT "No files have been found."
                LOCATE A + 5, 32: PRINT "Press any key to exit"

                WHILE INKEY$ = "": WEND
                RETURN

TxDSectorLength:    ' Calculate file length, in sectors
                TxDSectorLength& = CalcWord&(FilName$(TxDCurFilename%), 15) + 1
                RETURN

TxDShowErrorList:
                CALL box(8, 20, 50, 13,DoubleBorder$)
                LOCATE 9, 30: PRINT "Bad Sector List, File:"; MID$(FilName$(TxDCurFilename%), 1, 10)
                LOCATE 11 + W, 22: PRINT ""
                W = 0: A = 0
                LOCATE 11 + W, 22
                
                FOR J = 1 TO LEN(TxDFileErrList$(TxDCurFilename%)) STEP 2
                IF W > 8 THEN PRINT "..."; : GOTO TxDShowErrorList2
                K = CalcWord&(TxDFileErrList$(TxDCurFilename%), J)
                IF A > 0 THEN PRINT ",";
                PRINT RTRIM$(LTRIM$(STR$(K)));
                A = A + 1
                IF A > 8 THEN A = 0: W = W + 1: LOCATE 11 + W, 22
                NEXT J
TxDShowErrorList2:
                WHILE INKEY$ = "": WEND
                
NoTxDShowErrorList:
                RETURN
'========SHOW SECTORS
TxDShowSector:  CALL box(8, 3, 76, 13,DoubleBorder$)
                LOCATE 8, 30: COLOR HFC, HBC: PRINT " - HEX SECTOR VIEWER - "; : COLOR FC, BC
                CALL GetVirtualSect(TxDFileNum%, StartSect&(TxDCurFilename%) + 1, d$)
                TxDFHeader$ = d$
                IF CalcWord&(TxDFHeader$, 15) > 32767 GOTO TxDShowSectorEnd     ' PB 2004.06.05 - Handle FDR Error (BABA) -
                FileLength% = CalcWord&(TxDFHeader$, 15)
                LOCATE 9, 5:  PRINT "File: "; MID$(TxDFHeader$, 1, 10); "-Length:"; FileLength%;
                TxDSectorCnt& = CalcWord&(TxDFHeader$, 15)
                TxDGlobalInpOffset& = 0       ' GLOBAL TxDOffset in Input  File Chain Pointer Block
                TxDBlockOffset& = 0           ' TxDOffset of all the blocks so far in Input  File Chain Pointer Block
                Z = 0                         ' TxDOffset in Input File Chain Pointer Block
                K$ = "Y"
                
TxDShowSector2: GOSUB TxDCalcClusters
                TxDBlockOffset& = TxDBlockOffset& + TxDOffs&
TxDShowSector2z: IF TxDStSec& > 0 THEN GOTO TxDShowSector3
                LOCATE 19, 30: PRINT " = End of File =";
TxDShowSector2a:    DO: K$ = INKEY$: LOOP UNTIL K$ <> ""
                IF K$ = CHR$(27) THEN GOTO TxDShowSectorEnd
                IF K$ = CHR$(0) + CHR$(72) THEN GOTO TxDShowSector2b
                IF K$ = CHR$(0) + CHR$(73) THEN GOTO TxDShowSector2b
                GOTO TxDShowSector2a
TxDShowSector2b:  K$ = "Y"
                Z = Z - 3
                TxDGlobalInpOffset& = TxDGlobalInpOffset& - 1
                GOSUB TxDCalcClusters
                TxDOffsVal% = TxDOffs&
                GOTO TxDShowSector3a
                
TxDShowSector3:
                IF TxDGlobalInpOffset& > TxDBlockOffset& THEN Z = Z + 3: GOTO TxDShowSector2
TxDShowSector3a: CALL GetVirtualSect(TxDFileNum%, TxDStSec& + TxDOffsVal% + 1, d$)

                LOCATE 9, 35: PRINT " -This Skt: "; TxDStSec& + TxDOffsVal%; " >"; HEX$(TxDStSec& + TxDOffsVal%); " - Skt Off.:"; TxDGlobalInpOffset&;
                LOCATE 19, 30: PRINT "                ";
                CALL ShowHex(d$, K$)
                IF K$ = CHR$(27) THEN GOTO TxDShowSectorEnd
                IF K$ = CHR$(0) + CHR$(72) THEN GOTO TxDShowSector3b
                IF K$ = CHR$(0) + CHR$(73) THEN GOTO TxDShowSector3b
                GOTO TxDShowSector4
TxDShowSector3b:    
                IF TxDGlobalInpOffset& > 0 THEN K$ = ""
                IF TxDGlobalInpOffset& = 0 THEN GOTO TxDShowSector3
TxDShowSector3c: TxDGlobalInpOffset& = TxDGlobalInpOffset& - 1
                TxDOffsVal% = TxDOffsVal% - 1
                IF TxDOffsVal% >= 0 THEN GOTO TxDShowSector3a
                Z = Z - 3
                TxDBlockOffset& = TxDBlockOffset& - TxDOffs&:
                GOSUB TxDCalcClusters
                TxDOffsVal% = TxDOffs&
                GOTO TxDShowSector2z
                
TxDShowSector4:
                IF TxDGlobalInpOffset& < FileLength% THEN GOTO TxDShowSector5
                
                LOCATE 19, 30: PRINT " = End of File =";
TxDShowSector4a: DO: K$ = INKEY$: LOOP UNTIL K$ <> ""
                IF K$ = CHR$(27) THEN GOTO TxDShowSectorEnd
                IF K$ = CHR$(0) + CHR$(72) THEN GOTO TxDShowSector3c
                IF K$ = CHR$(0) + CHR$(73) THEN GOTO TxDShowSector3c
                GOTO TxDShowSector4a
                
                
TxDShowSector5:       
                TxDOffsVal% = TxDOffsVal% + 1           ' TxDOffset in EACH Input  File Chain Pointer Block
                TxDGlobalInpOffset& = TxDGlobalInpOffset& + 1
                GOTO TxDShowSector3
                
TxDShowSectorEnd:
                RETURN

' Prepare file to be cataloged upon by LZW decompressor
TxDARKextract:  CALL GetVirtualSect(TxDFileNum%, StartSect&(TxDCurFilename%) + 1, d$)
                TxDFHeader$ = d$
                TxDSectorLength& = CalcWord&(FilName$(TxDCurFilename%), 15) + 1
                Z = 0                      ' TxDOffset in Input File Chain Pointer Block
                TxDGlobalInpOffset& = 0       ' GLOBAL TxDOffset in Input  File Chain Pointer Block
                TxDSectorCnt& = TxDSectorLength& - 1' Sector Length of this file
                OPEN TempArk FOR BINARY ACCESS WRITE AS #2
                CLOSE #2
                KILL TempArk
                OPEN TempArk FOR BINARY ACCESS WRITE AS #2
                GOSUB TxDDoDisFix2
                RETURN

'===============================================
' CALCULATE CURRENT ENTRY IN CHAIN POINTER TABLE
'===============================================
' The second 3 nibble block contains the highest TxDOffsET within each Chain Block.
' This value must never be higher than TxDSectorCnt& - 1, which is the file total length - 2,
' as it appears on Disk Catalog.
' This corrects the bug on 80 track disks, that have the last second 3 nibble block wrong on
' ODD LENGTH FILES (1 sector longer).
' If not corrected, this bug would create an error on lower size disks.

TxDCalcClusters: IF Z > 227 THEN TxDStSec& = 0: GOTO TxDCalcClustend    ' PB 2004.06.05 - Handle FDR Error (BABA) -   
                A = ASC(MID$(TxDFHeader$, 28 + 1 + Z, 1))
                B = ASC(MID$(TxDFHeader$, 29 + 1 + Z, 1))
                C = ASC(MID$(TxDFHeader$, 30 + 1 + Z, 1))
                BA% = B MOD 16
                BB% = INT(B / 16)
                TxDStSec& = BA% * 256 + A
                IF TxDTotSect& > 4095 THEN TxDStSec& = TxDStSec& * KSectAU%
                TxDOffs& = C * 16 + BB
                IF TxDOffs& > TxDSectorCnt& - 1 THEN TxDOffs& = TxDSectorCnt& - 1
                TxDOffsVal% = 0               ' TxDOffset in EACH Input  File Chain Pointer Block
                
                GOTO TxDCalcClustend     ' Skip the below check, which has been superseeded by the simpler
                ' above approach:  IF TxDOffs& > TxDSectorCnt& - 1 THEN TxDOffs& = TxDSectorCnt& - 1
                ' Nonetheless, I leave it where it is because it might be still needed for some
                ' 80 track disks that have a wrong file length, beTxDSides having
                ' a wrong chain point table length.
                
' 
' Special case: in a 80 track Double Side Disk, when file length is EVEN (TxDSectorLength& in my code), the
' Chain Point Table reports 1 sector more than what it should. When copying, we have to use avoid using
' that extra sector. Method: always check if there is a next Data Chain. If there is, do nothing. Otherwise,
' that means we are are the end of the Data Chain, and we have to use a sector less.
' TxDSectorLength&

                
                IF TxDDens% < 2 OR TxDTracks < 80 THEN GOTO TxDCalcClustend
                IF TxDSectorLength& <> (INT(TxDSectorLength& / 2)) * 2 THEN GOTO TxDCalcClustend
                A = ASC(MID$(TxDFHeader$, 28 + 1 + Z + 3, 1))
                B = ASC(MID$(TxDFHeader$, 29 + 1 + Z + 3, 1))
                C = ASC(MID$(TxDFHeader$, 30 + 1 + Z + 3, 1))
                IF A <> 0 OR B <> 0 OR C <> 0 THEN GOTO TxDCalcClustend
                TxDOffs& = TxDOffs& - 1
TxDCalcClustend:
                
                RETURN
                
' Mark File containing Error: To save memory, a couple of bytes (CHR$) each bad sector
TxDMarkErrFile:
                MSB% = INT(K / 256)
                LSB% = K MOD 256
                TxDFileErrList$(TxDFileToCopy%) = TxDFileErrList$(TxDFileToCopy%) + CHR$(MSB%) + CHR$(LSB%)
                TxDErrInFile$=TxDErrInFile$ + CHR$(MSB%) + CHR$(LSB%) ' PB 2008.08.07 - Report Sector Errors that happen inside Files
                RETURN

' Mark File containing Error in FDR     ' PB 2004.06.05 - Handle FDR Error (BABA) -    
TxDMarkErrFileIF:                               ' PB 2004.06.05 - Handle FDR Error (BABA) -
                MSB% = INT(K / 256)     ' PB 2004.06.05 - Handle FDR Error (BABA) -
                LSB% = K MOD 256        ' PB 2004.06.05 - Handle FDR Error (BABA) -
                A$ = CHR$(MSB%) + CHR$(LSB%)    ' PB 2004.06.05 - Handle FDR Error (BABA) -
                ' PB 2008.08.10 IF LEN(TxDFileErrList$(TxDFileToCopy%)) > 0 AND RIGHT$(TxDFileErrList$(TxDFileToCopy%), 2) = A$ THEN GOTO TxDMarkErrFileIF2' PB 2004.06.05 - Handle FDR Error (BABA) -
                TxDFileErrList$(TxDFileToCopy%) = TxDFileErrList$(TxDFileToCopy%) + A$  ' PB 2004.06.05 - Handle FDR Error (BABA) -
                TxDErrInFDR$=TxDErrInFDR$+ A$  ' PB 2008.08.07 - Report separately Sector Errors that happen on FDR
TxDMarkErrFileIF2:      RETURN                  ' PB 2004.06.05 - Handle FDR Error (BABA) -
                
'PB 2008.8.6 - TxDDoDisFix:       OPEN TxDPath$ + FOut$ FOR BINARY ACCESS WRITE AS #2
TxDDoDisFix2:      Z = 0: Tog% = 1: BytePos& = 1: TRecs& = 0
                TxDTotRecs& = ASC(MID$(TxDFHeader$, 20, 1)) * 256 + ASC(MID$(TxDFHeader$, 19, 1))
                TxDRecsInSect% = ASC(MID$(TxDFHeader$, 14, 1))
                TxDLogRecLength% = ASC(MID$(TxDFHeader$, 18, 1))
                
                ' Special case: Archiver III files are sometimes bugged. The Total Records (Bytes 19+20 in FDR)
                ' sometimes report 256 records less than what it should.
                ' The following patch compares the Total Records
                ' with the Total Sector*2 which, in a dis/fix 128 record should be more or less comparable.
                ' If this is not the case, adds 256 bytes to previous value
                ' TxDTotRecs&=0:GOTO TxDNextClusterDF
                
                IF TxDLogRecLength% <> 128 THEN GOTO TxDNextClusterDF
                T& = (TxDSectorCnt& - 1) * 2
                IF T& <= TxDTotRecs& THEN GOTO TxDNextClusterDF
                TxDTotRecs& = TxDTotRecs& + 256
                ' PRINT " (fixed!)";
                ' print  "Total Records="; TxDTotRecs&  :input c$
                
TxDNextClusterDF:   GOSUB TxDCalcClusters
                IF TxDStSec& = 0 THEN GOTO TxDEOThisFileDF
                
TxDNextOffsValDF:
                
                IF TxDGlobalInpOffset& > TxDOffs& THEN Z = Z + 3: GOTO TxDNextClusterDF
                CALL GetVirtualSect(TxDFileNum%, TxDStSec& + TxDOffsVal% + 1, d$)
                GOSUB TxDRecToDoDF
                IF TxDTotRecs& < 1 THEN GOTO TxDEOThisFileDF
                TxDOffsVal% = TxDOffsVal% + 1           ' TxDOffset in EACH Input  File Chain Pointer Block
                TxDGlobalInpOffset& = TxDGlobalInpOffset& + 1
                
                ' DoneSect=DoneSect+1: PRINT TxDTotRecs&;DoneSect; TxDGlobalInpOffset&
                
                GOTO TxDNextOffsValDF

TxDEOThisFileDF:
                CLOSE #2
                
                RETURN

' Transfer a Dis/Var record (Text)
TxDRecToDoDF:   ROff% = 1

TxDRecToDoDFAG: FOR RT% = 1 TO TxDRecsInSect%
                DFRec$ = MID$(d$, ROff%, TxDLogRecLength%)
                PUT #2, BytePos&, DFRec$: BytePos& = BytePos& + TxDLogRecLength%
                ROff% = ROff% + TxDLogRecLength%
                TxDTotRecs& = TxDTotRecs& - 1
                TRecs& = TRecs& + 1
                IF TxDTotRecs& < 1 THEN GOTO TxDRecDoneDF
                NEXT RT%
                
TxDRecDoneDF:   RETURN

TxDirExit:
END SUB

SUB GetVirtualZero (FileNum%, d$)

                ByteOff& = 1
                MHSecLen% = 256
                DIM DAT(1) AS STRING * 256
                CALL TellWhatDisk(FileNum%, d$, WhatDisk$)
                DAT(1) = d$
                FType$ = WhatDisk$
                
                IF WhatDisk$ <> "MH" THEN GOTO GetVirtV9T9
                
'*** MESS HARD DISK ***       
                
                ERASE V9T9Sekt
                ERASE TrackSing
                ERASE TrackDoub
                
                ' Mess Hard Disk
                MHTB& = CalcDWord&(DAT(1), 28 + 1)  ' Get Total # of Blocks
                MHMapStart& = CalcDWord&(DAT(1), 8 + 1)  ' Get Hard Disk Header Size
                MHMapEnd& = MHTB& * 8 + MHMapStart&  ' Get Total # of Blocks * 8 + Hard Disk Header Size
                MHSectZero& = MHMapEnd& + 8
                MHSecLen% = CalcDWord&(DAT(1), 76 + 1) ' Get Hard Disk Sector Len
                
                ByteOff& = MHSectZero&
                IF MHSecLen% = 256 THEN ERASE MHSekt512 ELSE ERASE MHSekt256
                SELECT CASE MHSecLen%
                
                CASE 256
                GET #FileNum%, ByteOff& + 1, MHSekt256(1)
                d$ = MHSekt256(1)

                CASE 512
                GET #FileNum%, ByteOff& + 1, MHSekt512(1)
                d$ = MHSekt512(1)
                CASE ELSE
                PRINT "Unexpected Sector Length in Mess Hard Disk": SYSTEM
                END SELECT
                GOTO EstMedExit
                
GetVirtV9T9:  
                ERASE MHSekt256
                ERASE MHSekt512
                
                IF WhatDisk$ <> "VS" THEN GOTO GetVirtPC99SD
'*** V9T9 DISK ***                     
                
                ERASE TrackSing
                ERASE TrackDoub
                
                
                ' V-9T9 S-ingle density
                d$ = MID$(DAT(1), 1, 256)
                GOTO EstMedExit

GetVirtPC99SD:
                ERASE V9T9Sekt
                P = INSTR(DAT(1), CHR$(&HFE)): IF P = 0 THEN GOTO EstMedAbort
                IF WhatDisk$ <> "PS" THEN GOTO GetVirtPC99DD
                
'*** PC99 SINGLE DENSITY DISK ***             
                ERASE TrackDoub
                
                A$ = MID$(DAT(1), P + 4, 1)
                IF A$ <> CHR$(1) THEN GOTO EstMedAbort
                IF P <> 23 THEN GOTO EstMedAbort
                Gap1% = 16             ' Start of track Gap
                PreIDGap% = 7          '
                PreDatGap% = 31
                SLength% = 334
                SekTrack% = 9
                
                CONST TrkLenS% = 3253
                TrkLen& = TrkLenS%

                GET #FileNum%, 1, TrackSing(1)
                d$ = TrackSing(1)
                FType$ = "PS"          ' P-C99 S-ingle density
                
                GOTO GetSZero2

                
'*** PC99 DOUBLE DENSITY DISK ***
GetVirtPC99DD:
                IF WhatDisk$ <> "PD" THEN GOTO EstMedAbort
                ERASE TrackSing

                IF P <> 54 THEN GOTO EstMedAbort
                Gap1% = 40             ' Start of track Gap
                PreIDGap% = 14
                PreDatGap% = 58
                SLength% = 340
                SekTrack% = 18
                
                CONST TrkLenD% = 6872
                TrkLen& = 6872
                GET #FileNum%, 1, TrackDoub(1)
                d$ = TrackDoub(1)

GetSZero2:
                OldTrack& = 0
                OldDskSide& = 0
                SideLen& = TrkLen& * 40
                FOR T = 1 TO SekTrack%
                P = 1 + Gap1% + PreIDGap% + (SLength% * (T - 1))
                A$ = MID$(d$, P, 4)
                
                IF A$ = CHR$(0) + CHR$(0) + CHR$(0) + CHR$(1) THEN GOTO SZeroFnd
                NEXT T
                GOTO EstMedAbort
SZeroFnd:       P = 1 + Gap1% + PreDatGap% + (SLength% * (T - 1))
                d$ = MID$(d$, P, 256)
                GOTO EstMedExit
                

EstMedAbort:    FType$ = "": d$ = ""
EstMedExit:     ERASE DAT
END SUB

DEFSNG A-Z
' READ A SECTOR FROM ANY OF THE FOLLOWING : PC99 DISK, V9T9 DISK, TI99-PC DISK, MESS HARD DISK
SUB GetVirtualSect (FileNum%, Sektor&, d$)
                Sekr& = Sektor& - 1
                
                IF FType$ <> "MH" THEN GOTO NoMHDisk            ' See if it is a Mess Hard Disk
                ByteOff& = Sekr& + 1
                ByteOff& = ByteOff& * MHSecLen% + MHSectZero&
                SELECT CASE MHSecLen%
                CASE 256
                GET #FileNum%, ByteOff& + 1, MHSekt256(1)
                d$ = MHSekt256(1)
                CASE 512
                GET #FileNum%, ByteOff& + 1, MHSekt512(1)
                d$ = MHSekt512(1)
                END SELECT
                GOTO GetSectExit
                
                
                
NoMHDisk:  
                IF FType$ <> "VS" THEN GOTO PC99disk            ' V-9T9 S-ingle density
'*** V9T9 DISK ***            
                ByteOff& = Sekr&
                ByteOff& = ByteOff& * MHSecLen%
                GET #FileNum%, ByteOff& + 1, V9T9Sekt(1)
                d$ = V9T9Sekt(1)
                GOTO GetSectExit
                
PC99disk:       Trk& = INT(Sekr& / SekTrack%)
                DskSide& = 0
                IF Trk& > 39 THEN Trk& = 79 - Trk&: DskSide& = 1
                Skt% = Sekr& MOD SekTrack%
                
                IF FType$ = "PD" THEN GOTO GetSectD
                IF FType$ = "PS" THEN GOTO GetSectS


GetSectS:       IF Trk& = OldTrack& AND DskSide& = OldDskSide& THEN GOTO GetSectS03
'*** PC99 SINGLE DENSITY DISK ***
                ByteOff& = SideLen& * DskSide& + Trk& * TrkLen&
                GET #FileNum%, ByteOff& + 1, TrackSing(1)
                OldTrack& = Trk&: OldDskSide& = DskSide&
                
GetSectS03:     FOR WHT% = 1 TO SekTrack%
                P = 1 + Gap1% + PreIDGap% + (SLength% * (WHT% - 1))
                A$ = MID$(TrackSing(1), P, 4)
                
                IF A$ <> CHR$(Trk&) + CHR$(DskSide&) + CHR$(Skt%) + CHR$(1) THEN GOTO GetSectS05
                d$ = MID$(TrackSing(1), 1 + Gap1% + PreDatGap% + (SLength% * (WHT% - 1)), 256)
                GOTO GetSectExit
                
GetSectS05:     NEXT WHT%
                
                GOTO GetSectBad:
                
GetSectD:       IF Trk& = OldTrack& AND DskSide& = OldDskSide& THEN GOTO GetSectD03
'*** PC99 DOUBLE DENSITY DISK ***     
                ByteOff& = SideLen& * DskSide& + Trk& * TrkLen&
                GET #FileNum%, ByteOff& + 1, TrackDoub(1)
                OldTrack& = Trk&: OldDskSide& = DskSide&
                
GetSectD03:     FOR WHT% = 1 TO SekTrack%
                P = 1 + Gap1% + PreIDGap% + (SLength% * (WHT% - 1))
                A$ = MID$(TrackDoub(1), P, 4)
                
                IF A$ <> CHR$(Trk&) + CHR$(DskSide&) + CHR$(Skt%) + CHR$(1) THEN GOTO GetSectD05
                d$ = MID$(TrackDoub(1), 1 + Gap1% + PreDatGap% + (SLength% * (WHT% - 1)), 256)
                GOTO GetSectExit
                
GetSectD05:     NEXT WHT%

GetSectBad:     d$ = ""
                
GetSectExit:
END SUB

SUB ShortLongName (A$,B$,FUNC As Integer)
' Get either a LongName or a Shortname, depending on the value assigned to the control variable FUNC
' FUNC = 1  -  Get ShortFilename (8.3 characters) out of a LongFilename. 
'                  Return the Longest Filename available, but don't create a new file if none exists.
'      = 2  -  Get LongFilename. 
'                  Return the Longest Filename available, but don't create a new file if none exists.
'      = 3  -  Get ShortFilename (8.3 characters) out of a LongFilename. Create one LongFilename if no ShortFilename exists.
'                  Return the shortest Filename available. If file is created, a second record containing "CR!" will be returned.
'      = 4  -  Get Long Filename out of a short one. Create a long one if none exists. 
'                  Return the longest Filename available. If file is created, a second record containing "CR!" will be returned. 
'      = 5  -  Get Long Filename out of a short one. Create a long one if none exists. 
'                  Return the shortest Filename available. If file is created, a second record containing "CR!" will be returned.

                SELECT CASE MyVal(0)
                CASE 0 TO 999  ' Plain DOS OS
                EXIT SUB
                CASE 1000 TO 1999  ' Windows 95, 98, XP
                GOTO ShortLongN1
                CASE 2000 TO 3000  ' Windows XP, Vista
                GOTO ShortLongN1
                CASE ELSE
                END SELECT
                EXIT SUB
                
ShortLongN1:    Select CASE FUNC
                CASE 1  ' Get short filename (8.3 characters) but don't create a new file.
                C$ = "INT7160.com"
                CASE 2  ' Get Longest Filename but don't create a new file.
                C$ = "INT716RL.com"
                CASE 3  ' Get ShortFilename and create a long one if none exists. Return the short one anyway
                C$ = "INT716C.com"
                CASE 4  ' Get Long Filename out of a short one. Create a long one if none exists.
                C$ = "INT716CO.com"  ' The new  filename returned to the caller will be of the longest type available.
                CASE 5  ' Get Long Filename out of a short one. Create a long one if none exists.
                C$ = "INT716CL.com"  ' The new  filename returned to the caller will be of the shortest type available.

                CASE Else
                Exit Sub
                END SELECT
                
                
                C$ = C$ + " " + A$ + " >--"'Redirect output to a file named "--"
                SHELL C$
                B$=""
                ff% = FREEFILE
                OPEN "--" FOR INPUT AS #ff%
                IF EOF(ff%) <> 0 THEN GOTO ShortLongN2
                LINE INPUT #ff%, A$
                IF EOF(ff%) <> 0 THEN GOTO ShortLongN2
                LINE INPUT #ff%, B$
ShortLongN2:    CLOSE #ff%
                KILL "--"
END Sub

DEFINT A-Z
Sub box (Y, X, W, H, Charac$)
                ' Call Box(StartRow, StartColumn, Width, Height, BoxChar$)
                ' Y=StartRow,X=StartColumn; W=Width,H=Height)
                
                TL$ = MID$(Charac$, 1, 1)
                t$ = MID$(Charac$, 2, 1)
                TR$ = MID$(Charac$, 3, 1)
                L$ = MID$(Charac$, 4, 1)
                R$ = MID$(Charac$, 5, 1)
                BL$ = MID$(Charac$, 6, 1)
                B$ = MID$(Charac$, 7, 1)
                BR$ = MID$(Charac$, 8, 1)

'DoubleBorder$="ͻͼ"        ' Double Border Box characters  
'SingleBorder$="Ŀ"        ' Single Border Box characters  
                LOCATE Y, X
                PRINT TL$; : FOR t = 1 TO W - 2: PRINT t$; : NEXT t: PRINT TR$;
                
                FOR v = 1 TO H - 2
                LOCATE Y + v, X
                PRINT L$; TAB(X + W - 1); : PRINT R$;
                NEXT v
                
                LOCATE Y + H - 1, X
                PRINT BL$; : FOR t = 1 TO W - 2: PRINT B$; : NEXT t: PRINT BR$;

END SUB


FUNCTION CalcDWord& (A$, P%)
                IF LEN(A$) < P% + 3 THEN INPUT "Wrong String in CalcDoubleWord Subroutine", C$: V& = 0: GOTO CalcDWord1
                
                B1& = ASC(MID$(A$, P%, 1))
                B2& = ASC(MID$(A$, P% + 1, 1))
                B3& = ASC(MID$(A$, P% + 2, 1))
                B4& = ASC(MID$(A$, P% + 3, 1))
                V& = (B1& * 16777216) + (B2& * 65536) + (B3& * 256) + B4&
                
CalcDWord1:     CalcDWord& = (V&)
                
END FUNCTION

FUNCTION CalcWord& (A$, P%)
                IF LEN(A$) < P% + 1 THEN INPUT "Wrong String in CalcWord Subroutine", C$: V% = 0: GOTO CalcWord1
                B1& = ASC(MID$(A$, P%, 1))
                B2& = ASC(MID$(A$, P% + 1, 1))
                V& = (B1& * 256) + B2&
CalcWord1:      CalcWord& = (V&)
END FUNCTION

SUB ERRSOUND
                SOUND 110, 4

END SUB

SUB Fischio
                IF MyVal(1) = 0 THEN EXIT SUB
                FOR i% = 3000 TO 4000 STEP 200
                SOUND i%, .1  'i% / 1000
                NEXT i%

END SUB

SUB ShowHex (A$, K$)
' This is simply to help during debugging
' Syntax: CALL ShowHex(A$,K$) ' A$ usually contains an entire TI Sector (256 bytes)
                Col% = 3
                B$ = ""
                FOR T = 1 TO LEN(A$)
                C$ = HEX$(ASC(MID$(A$, T, 1))): IF LEN(C$) = 1 THEN C$ = "0" + C$
                B$ = B$ + C$ + " "
                NEXT T
                
                LOCATE 10, Col% + 2
                PRINT "Addr. 0  1  2  3  4  5  6  7  8  9  A  B  C  D  E  F ";
                
                IF K$ = "" THEN T = LEN(B$) - (8 * 16 * 3 - 1) ELSE T = 1
'===============LOOP STARTS HERE
                
Repeat:
                T$ = MID$(B$, T, 16 * 3)
                LOCATE 10 + 1 + Row%, Col% + 1:
                H$ = HEX$(T / 3)
                IF LEN(H$) = 1 THEN H$ = "00" + H$ ELSE IF LEN(H$) = 2 THEN H$ = "0" + H$
                PRINT USING "\   \"; H$;
                LOCATE 10 + 1 + Row%, Col% + 5
                PRINT " - "; T$;
                PRINT "  ";
                FOR J = 1 TO 16
                J$ = MID$(A$, (T - 1) / 3 + J, 1)
                IF ASC(J$) < 32 OR ASC(J$) > 126 THEN PRINT " ";  ELSE PRINT J$;
                
                NEXT J
                
                Row% = Row% + 1: IF Row% < 8 THEN GOTO NextRow ELSE Row% = 0
                'locate 21,1: print len(B$)
                'locate 22,1: print t
                'locate 23,1: print (t-1)/(3*16)
                DO
                K$ = INKEY$
                LOOP UNTIL K$ <> ""
                K$ = UCASE$(K$)
                IF K$ = CHR$(27) THEN GOTO GEXIT
                
                ' Arrow Down
                IF K$ <> CHR$(0) + CHR$(80) THEN GOTO ArrowUPkey
                T = T - (16 * 3 * 6): IF T < 1 THEN T = 1
                GOTO Repeat
                
ArrowUPkey:      ' Arrow UP
                IF K$ <> CHR$(0) + CHR$(72) AND K$ <> CHR$(0) + CHR$(73) THEN GOTO NextRow
                IF K$ <> CHR$(0) + CHR$(72) THEN GOTO PageUPKey
                IF T < 8 * 16 * 3 THEN K$ = CHR$(0) + CHR$(72): GOTO GEXIT
                T = T - (16 * 3 * 8): IF T < 1 THEN T = 1
                GOTO Repeat
PageUPKey:
                ' Page UP
                IF T < 8 * 16 * 3 THEN K$ = CHR$(0) + CHR$(72): GOTO GEXIT
                T = T - (16 * 3 * 15): IF T < 1 THEN T = 1
                GOTO Repeat

NextRow:
                T = T + (16 * 3)
                IF T < LEN(B$) THEN GOTO Repeat
                K$ = "Y"
'===============LOOP ENDS HERE
GEXIT:
END SUB

DEFSNG A-Z
SUB TellWhatDisk (FileNum%, d$, WhatDisk$)
                MHSecLen% = 256
                DIM DAT(1) AS STRING * 256
                GET #FileNum%, 1, DAT(1)
                d$ = DAT(1)
                IF MID$(DAT(1), 1, 8) <> "MComprHD" THEN GOTO TellDSKDetect
                WhatDisk$ = "MH": GOTO TellWhatDExit
TellDSKDetect:
                
                IF MID$(DAT(1), 14, 3) <> "DSK" THEN GOTO TellPC99Detect
                WhatDisk$ = "VS": GOTO TellWhatDExit
                
                
TellPC99Detect: P = INSTR(DAT(1), CHR$(&HFE)): IF P = 0 THEN GOTO TellWhatDAbort
                A$ = MID$(DAT(1), P + 4, 1)
                IF A$ <> CHR$(&H1) THEN GOTO TellWhatDAbort
                A$ = MID$(DAT(1), P - 3, 3)
                IF A$ = CHR$(&HA1) + CHR$(&HA1) + CHR$(&HA1) THEN WhatDisk$ = "PD": GOTO TellWhatDExit
                IF A$ <> CHR$(0) + CHR$(0) + CHR$(0) THEN GOTO TellWhatDAbort
                WhatDisk$ = "PS": GOTO TellWhatDExit
                
TellWhatDAbort: WhatDisk$ = "": d$ = ""

TellWhatDExit:  ERASE DAT
END SUB

DEFINT A-Z
SUB GetOffsetMask(SectNum%,ByteOff%,BitMask%)
' FREE/USED SECTOR TOOLS
' Returns an Offset and a Mask value from an 16 bit number. Offset is a byte offset on a bit map table, such 
' as the Used/Free Sector Bit Map Table of a floppy. Mask is a single bit value inside a byte value (8 bits), 
' such as 1,2,4,8,16,32,64,128. The Offset and the Mask can be used by  caller to check if a given sector is 
' Free or Used. 
'Syntax: CALL GetOffsetMask(SectNumber%,ReturnedByteOff%,ReturnedMask%)
'
                ByteOff% = INT(SectNum%/ 8)
                BitMask% = 2^(SectNum% MOD 8) 

END SUB 



DOSAsmblFilename:
                
                IF CurrentFilename% <= 5 THEN BEEP: Mystring$ = "": GOTO DOSAsmblFilexit
                Get #4, CurrentFilename%
                
DOSAsmblFilXpres:
                Mystring$ = XtrctFilename$(L$)
                IF LEFT$(L$, 1) = "\" THEN BEEP: Mystring$ = "": GOTO DOSAsmblFilexit
                ' Mystring$ = LEFT$(L$, 12)
                Mystring$ = Shrink$(Mystring$): If Mystring$ = "" Then BEEP: GoTo DOSAsmblFilexit
                Mystring$ = CurrDir$ + Mystring$
DOSAsmblFilexit:
                RETURN

FUNCTION XtrctFilename$ (A$)    ' Get long filename, is available; if not get the short one    
                SELECT CASE MyVal(0)
                CASE 0 TO 999  ' Plain DOS OS
                GoTo XtrctFilename1
                CASE 1000 TO 1999  ' Windows 95, 98, ME
                B$ = RTRIM$(LTRIM$(MID$(A$, MyVal(3), LEN(A$))))
                IF B$ <> "" THEN GoTo XtrctFilename4
                GoTo XtrctFilename1
                CASE 2000 TO 2099  ' Windows XP
                B$ = RTRIM$(LTRIM$(MID$(A$, MyVal(3), LEN(A$))))
                IF B$ = "" THEN B$ = MID$(A$, 2, 2)     ' In case "\.." (Parent Directory) is selected
                CASE 2100 TO 3000  ' Windows Vista
                B$ = RTRIM$(LTRIM$(MID$(A$, MyVal(3), LEN(A$))))
                IF B$ = "" THEN B$ = MID$(A$, 2, 2)     ' In case "\.." (Parent Directory) is selected
                END Select
                GoTo XtrctFilename4
                
                
                
XtrctFilename1: B$ =RTRIM$(LTRIM$(MID$(A$, 1, 13)))
                P = INSTR(1, B$, " "): IF P > 0 THEN MID$(B$, P) = "."
                IF LEFT$(B$, 1) = "\" THEN B$=RIGHT$(B$,Len(B$)-1)
                
                
XtrctFilename4: XtrctFilename$ = B$
END FUNCTION                            

FUNCTION Shrink$ (In$)
                A$ = "": c1$ = " "
                FOR T = 1 TO LEN(In$): C$ = MID$(In$, T, 1): IF C$ = " " AND c1$ = " " THEN GOTO SKIP
                A$ = A$ + C$: c1$ = C$
SKIP:
                NEXT T
                A$ = LTRIM$(RTRIM$(A$))
                Shrink$ = A$
END FUNCTION

FUNCTION Dec2Hex$ (X%)
                A$ = ""
                B$ = "0123456789ABCDEF"
                FOR T = 4 TO 15 STEP 4
                J% = 2 ^ T
                K% = X% MOD 16
                
                
                A$ = MID$(B$, K% + 1, 1) + A$
                X% = (X% - K%) / 16
                IF X% < 1 THEN GOTO Dec2HexEnd
                NEXT T
Dec2HexEnd:           
                Dec2Hex$ = A$
END FUNCTION

DEFINT A-Z

                FUNCTION Xinput$ (Row%, Col%, FieldLen%, Default$, AllowCharsMask$, EndingKeys$, ExitKey$, RealStrLen%) STATIC

'Ŀ
'         XINPUT 2.1:  A Powerful Replacement for standard QBasic INPUT       
'                 
'                              First written                                  
'                                   by                                        
'          Frederick Volking, QBNews, Volume  1, Number  3  May 22, 1990      
'                                                                             
'                    ͻ                      
'                             Paolo Bagnaresi                               
'                           Via J.F. Kennedy 17                             
'                      20097 San Donato Milanese (MI)                       
'                                Italy                                      
'                          Tel. ++39-2-514.202                              
'                                                     
'                    e-mail: paul.bagnaresi@gmail.com 
'                    ͼ                      
'                                                                             
'          Almost entirely rewrote it and deeply enhanced it on June 1995     
'                                                                             
' Vers. 2.0 : Some bad bugs corrected on March 1996 (cursor position and      
'             returned string length)                                         
' Vers. 2.1 : May 2000. FieldLen% bug fixed.                                  
'Ĵ
'SYNTAX:Xinput$(Row%,Col%,FLen%,Default$,Allow$,EndKeys$,ExitKey$,RealStrLen%)
'WHERE: Row% & Col% - where input to occur                                    
'         FLen% - Field Length - maximum allowable                            
'         Default$ - Field's beginning default value                          
'         Allow$ - Character Set allowable for input                          
'         EndKeys$ - Keystrokes acceptable for finishing.                     
'            SUCH: [Enter] is CHR$(13)                                        
'                  [Esc] is CHR$(27)                                          
'                  [F1] is CHR$(255)+CHR$(59)                                 
'                  [Ctrl+PgUp] is CHR$(255)+CHR$(132)                         
'                  ... etc                                                    
'         ExitKey$ - The keystroke (from above EndKeys$)                      
'                    which was struck at function end.                        
'         RealStrLen% - The Real String Length, not counting unused space     
'                       at the string end. However, Spaces added manually     
'                       do count!                                             
'  SIMPLEST USE:  A$ = Xinput$(0,0,0,"","","",Any$,RealStrLen%)               
'         Will default to cursor's current row/col, length is                 
'         autoset to right margin, allowable chars are ALL,                   
'         only ending key is [Enter].                                         
'Ĵ
'                                                                             
'   Instructions and enhancements discussion after the end of program         
'                           ***  see below ***                                
'                                                                             
'
'  Discussion 
'
'                 XINPUT program eXtends the standard QBasic INPUT.
'
'     Unlike QB INPUT, XINPUT allows editing a previously created string.
'     This is the strongest feature of Xinput and the very reason why this
'     task was undertaken. I just could not bear any longer the tedious
'     retyping of any string change that was needed in some program
'     I developed through the years.
'     The original routine written by Frederick Volking on QBNews, named
'     ENPUT,  did not alllow a string editing, which is why I felt compelled
'     to rewrite the Volking routine.
'
'     Other valuable features are:
'
'- Exit keys (Xinput terminators) are user selectable, and detectable by caller.
'- All the user allowed keys are also pre-selectable. Caller can create a mask
'  containing the all the keys that the callee will be allowed to use.
'  A low sound will signal hitting an unselected key.
'
'- Insert key remains active until you deselect it by pressing it again.
'- Backspace pressed 8 times at 1st string position reverts you to start string.
'- Screen start position is user selectable.
'- Cursor Up key and Cursor Down key will move you through the rows.
'- Page Up will moves you to first row. Page Down to the last row.
'- CTRL+Home erases all the field from cursor position up to 1st string char.
'- All the standard QB Input features are emulated, including CTRL+End,
'  CTRL+R, CTRL+E, Tab and CTRL+I...
'- Escape key or CTRL+U, if aren't redefined as an exit key, will entirely
'  blank the string field.
'- Source code in plain QBasic is here, waiting for your enhancements.
'  BTW, I would gladly receive your enhancements, if you can send them to my
'  address:                   Paolo Bagnaresi
'                           Via J.F. Kennedy 17
'                      20097 San Donato Milanese (MI)
'                                Italy
'                          Tel. ++39-2-514.202
'                   e-mail: paul.bagnaresi@gmail.com 

                SHARED ScreenWidth%, EmptySpaceChar$

' 1 character Key vakues
                CtrlB$ = CHR$(2)         ' Ctrl+ B = Cursor to the word on the left
                CtrlE$ = CHR$(5)         ' Ctrl+ E = Cancel all chars from Cursor Posit. to end
                CtrlF$ = CHR$(6)         ' Ctrl+ F = Cursor to the word on the right
                BackS$ = CHR$(8)         ' Backspace
                Tabul$ = CHR$(9)         ' Tabulator
                CtrlI$ = CHR$(9)         ' Ctrl+ I = Tabulator
                CtrlK$ = CHR$(11)        ' Ctrl+ K = Cursor to start of field (= Home)
                Enter$ = CHR$(13)        ' Enter
                CtrlN$ = CHR$(14)        ' Ctrl+ N = Cursor to end of field (= End)
                CtrlR$ = CHR$(18)        ' Ctrl+ R = Insert mode toggle
                CtrlU$ = CHR$(21)        ' Ctrl+ U = Clear all input field
                Esc$ = CHR$(27)          ' Escape
                CtrlRevSlash$ = CHR$(28) ' Ctrl+ \ = Cursor Right
                CtrlClSquare$ = CHR$(29) ' Ctrl+ ] = Cursor Left
                
                CTRLC$ = CHR$(3)         ' CTRL+ C
                CTRLV$ = CHR$(22)        ' CTRL+ V

' 2 character Key vakues
                CursLeft$ = CHR$(0) + CHR$(75)
                CursRight$ = CHR$(0) + CHR$(77)
                CursUp$ = CHR$(0) + CHR$(72)
                CursDown$ = CHR$(0) + CHR$(80)

                Insert$ = CHR$(0) + CHR$(82)
                Delete$ = CHR$(0) + CHR$(83)
                Home$ = CHR$(0) + CHR$(71)
                End$ = CHR$(0) + CHR$(79)
                PageUp$ = CHR$(0) + CHR$(73)
                PageDown$ = CHR$(0) + CHR$(81)

                CtrlHome$ = CHR$(0) + CHR$(119)
                CtrlEnd$ = CHR$(0) + CHR$(117)
                CtrlPageUp$ = CHR$(0) + CHR$(132)
                CtrlPageDown$ = CHR$(0) + CHR$(118)
                CtrlCursLeft$ = CHR$(0) + CHR$(115)
                CtrlCursRight$ = CHR$(0) + CHR$(116)


' Other Key vakues, currently unused
                F1$ = CHR$(59)           'F1
                F2$ = CHR$(60)           'F2
                F3$ = CHR$(61)           'F3
                F4$ = CHR$(62)           'F4
                F5$ = CHR$(63)           'F5
                F6$ = CHR$(64)           'F6
                F7$ = CHR$(65)           'F7
                F8$ = CHR$(66)           'F8
                F9$ = CHR$(67)           'F9
                F10$ = CHR$(68)          'F10
                F10$ = CHR$(133)         'F11
                F10$ = CHR$(134)         'F12

' Verify if SHARED globals are set
                IF ScreenWidth% = 0 THEN ScreenWidth% = 80
                IF LastRow% = 0 THEN LastRow% = 24
                TotalScreenLength% = LastRow% * ScreenWidth%
                IF EmptySpaceChar$ = "" THEN EmptySpaceChar$ = CHR$(32)

' If not specified then supply defaults to incoming vars
                IF AllowCharsMask$ = "" THEN AllowCharsMask$ = CHR$(34) + " !#$%&'()*+,-./0123456789:;<=>?@ABCDEFGHIJKLMNOPQRSTUVWXYZ[\]^_`abcdefghijklmnopqrstuvwxyz{|}~"
                IF EndingKeys$ = "" THEN EndingKeys$ = CHR$(13)
                IF Row% = 0 THEN Row% = CSRLIN
                IF Col% = 0 THEN Col% = POS(0)
                ReturnVar$ = Default$
                IF FieldLen% = 0 THEN FieldLen% = LEN(ReturnVar$)
                IF FieldLen% <= LEN(ReturnVar$) THEN GOTO FieldLenOk
                ReturnVar$ = ReturnVar$ + STRING$(FieldLen% - LEN(ReturnVar$), EmptySpaceChar$)
                FieldLen% = LEN(ReturnVar$)
                Default$ = ReturnVar$
                
FieldLenOk:
' Define internal defaults

                CursPos% = 1
                ReturnVar$ = Default$
                Separator$ = " !#$%&'()*+,-./:;<=>?@[\]^_`{|}~" + CHR$(34) ' Valid separators for CTRL+LEFT or CTRL+RIGHT
                IF TabLen% = 0 THEN TabLen% = 8 ' Tabulator lenght
                NotDone% = 1
                standard% = 6 'Cursor Shape if in Standard Mode
                Insert% = 4   'Cursor Shape if in Insert Mode
                CurShape% = standard%

'  MAIN LOOP STARTS HERE 
                Riga% = Row%: Lonna% = Col%
                DO
                LOCATE Riga%, Lonna%, 0
                IF Lonna% + LEN(ReturnVar$) > ScreenWidth% THEN
                Part1$ = LEFT$(ReturnVar$, ScreenWidth% - Lonna% + 1)
                Part2$ = RIGHT$(ReturnVar$, LEN(ReturnVar$) - (ScreenWidth% - Lonna% + 1))
                ELSE
                Part1$ = ReturnVar$: Part2$ = ""
                END IF
                PRINT Part1$; Part2$;

                RowCurs% = INT((Lonna% + CursPos% - 1) / ScreenWidth%)
                ColCurs% = (Lonna% + CursPos% - 1) MOD ScreenWidth%
                IF ColCurs% = 0 THEN ColCurs% = ScreenWidth%: RowCurs% = RowCurs% - 1
                VirtPos% = (Riga% * ScreenWidth% - 1) + Lonna% + FieldLen%
                IF VirtPos% > TotalScreenLength% THEN
                Riga% = Riga% - (INT((VirtPos% - TotalScreenLength% - 1) / ScreenWidth%))

                LOCATE Riga%, Lonna%, 0
                END IF
                LOCATE Riga% + RowCurs%, ColCurs%, 1, CurShape%, 7
                DO
                KeyStroke$ = INKEY$
                LOOP WHILE KeyStroke$ = ""


                If INSTR(AllowCharsMask$, KeyStroke$) > 0 THEN
                Mark% = 0'No Backspace at Posit. 0
                IF CurShape% = standard% THEN
                MID$(ReturnVar$, CursPos%, 1) = KeyStroke$

                ELSE
                ReturnVar$ = LEFT$(ReturnVar$, CursPos% - 1) + KeyStroke$ + MID$(ReturnVar$, CursPos%, FieldLen% - CursPos%)
                END IF

                IF CursPos% < FieldLen% THEN
                CursPos% = CursPos% + 1
                ELSE
                IF MyVal(1) <> 0 AND FieldLen%>1 THEN BEEP
                END IF
                ELSE

                IF INSTR(EndingKeys$, KeyStroke$) > 0 THEN
                ExitKey$ = KeyStroke$
                NotDone% = 0
                ELSE
'  Check for other keys  

                SELECT CASE KeyStroke$
                CASE CursLeft$
                IF CursPos% > 1 THEN
                CursPos% = CursPos% - 1
                END IF
                CASE CursRight$
                IF CursPos% < FieldLen% THEN
                CursPos% = CursPos% + 1
                END IF
                CASE BackS$
                IF CursPos% > 1 THEN
                Mark% = 0'No Backspace at Posit. 0
                ReturnVar$ = LEFT$(ReturnVar$, CursPos% - 2) + RIGHT$(ReturnVar$, FieldLen% - CursPos% + 1) + EmptySpaceChar$
                CursPos% = CursPos% - 1
                ELSE
                Mark% = Mark% + 1:
                SOUND Mark% * 400 + 500, 1
                IF Mark% > 7 THEN
                Mark% = 0
                ReturnVar$ = Default$
                ' IF LEN(ReturnVar$) < FieldLen% THEN
                '    ReturnVar$ = ReturnVar$ + SPACE$(FieldLen% - LEN(ReturnVar$))
                ' END IF
                END IF
                END IF
                CASE Delete$
                ReturnVar$ = LEFT$(ReturnVar$, CursPos% - 1) + RIGHT$(ReturnVar$, FieldLen% - CursPos%) + EmptySpaceChar$
                CASE Insert$, CtrlR$
                IF CurShape% = standard% THEN
                CurShape% = Insert%
                ELSE CurShape% = standard%
                END IF

                CASE Home$, CtrlK$  ' Cursor to field start
                CursPos% = 1

                CASE End$, CtrlN$  ' Cursor to field end
                CursPos% = LEN(ReturnVar$)

                CASE CursUp$  ' Cursor 1 line up
                IF CursPos% > ScreenWidth% THEN CursPos% = CursPos% - ScreenWidth%

                CASE CursDown$ ' Cursor 1 line down
                IF CursPos% + ScreenWidth% < LEN(ReturnVar$) + 1 THEN CursPos% = CursPos% + ScreenWidth%

                CASE CtrlHome$  ' Cancel all chars from Cursor Position -1  up to start
                ReturnVar$ = RIGHT$(ReturnVar$, FieldLen% - CursPos% + 1) + STRING$(CursPos% - 1, EmptySpaceChar$)
                CursPos% = 1

                CASE CtrlEnd$, CtrlE$ ' Ctrl+ E = Cancel all chars from Cursor Posit. up to end
                ReturnVar$ = LEFT$(ReturnVar$, CursPos% - 1) + STRING$(FieldLen% - CursPos% + 1, EmptySpaceChar$)

                CASE PageUp$  ' Cursor to 1st line
                DO WHILE CursPos% > ScreenWidth%
                CursPos% = CursPos% - ScreenWidth%
                LOOP

                CASE PageDown$ ' Cursor to last line
                DO WHILE CursPos% + ScreenWidth% < LEN(ReturnVar$) + 1
                CursPos% = CursPos% + ScreenWidth%
                LOOP

                CASE CtrlCursLeft$, CtrlB$ ' Ctrl+ B = Cursor to the word on the left
                IF CursPos% > 1 THEN
                P% = CursPos% - 1
                DO WHILE (P% > 1) AND INSTR(Separator$, MID$(ReturnVar$, P%, 1)) > 0
                P% = P% - 1
                LOOP

                DO WHILE (P% > 1) AND INSTR(Separator$, MID$(ReturnVar$, P%, 1)) = 0
                P% = P% - 1
                LOOP
                CursPos% = P%
                IF CursPos% < 1 THEN CursPos% = 1
                IF CursPos% > 1 THEN CursPos% = CursPos% + 1
                END IF

                CASE CtrlCursRight$, CtrlF$ ' Ctrl+ F = Cursor to the word on the right
                P% = CursPos%
                DO WHILE (P% < FieldLen%) AND INSTR(Separator$, MID$(ReturnVar$, P%, 1)) = 0
                P% = P% + 1
                LOOP
                DO WHILE (P% < FieldLen%) AND INSTR(Separator$, MID$(ReturnVar$, P%, 1)) > 0
                P% = P% + 1
                LOOP

                CursPos% = P%
                IF CursPos% > FieldLen% THEN CursPos% = FieldLen%

                CASE Esc$, CtrlU$  ' Ctrl+ U = Clear all input field, if Escape is not
                ' activate to exit by XINPUT caller
                ReturnVar$ = STRING$(FieldLen%, EmptySpaceChar$)
                CursPos% = 1

                CASE Tabul$  ' Tabulator in QBasic works in the following way:
                ' Cursor moves to past the NEXT 8th character,
                '   character 1 in string being 1st character.
                ' I.e., to 9th, 17th, 25th, 33rd character and so on.
                ' If INSERT key is not active, up to 8 character will be blanked.
                ' If INSERT key is ACTIVE, up to 8 blanks will be INSERTED.

                P% = (INT((CursPos% - 1 + TabLen%) / TabLen%) * TabLen%) + 1 ' Find Cursor position of next tabulation
                IF P% > FieldLen% + 1 THEN P% = FieldLen% + 1
                IF CursPos% > 1 THEN R1$ = LEFT$(ReturnVar$, CursPos% - 1) ELSE R1$ = ""
                IF CurShape% = standard% THEN
                IF CursPos% < P% THEN R2$ = RIGHT$(ReturnVar$, FieldLen% - P% + 1) ELSE R2$ = ""
                ELSE
                IF CursPos% < FieldLen% THEN R2$ = MID$(ReturnVar$, CursPos%, FieldLen% + 1 - P%) ELSE R2$ = ""
                END IF
                ReturnVar$ = R1$ + STRING$(P% - CursPos%, CHR$(32)) + R2$
                IF P% > FieldLen% THEN P% = FieldLen%
                CursPos% = P%
                
                Case CTRLC$  ' CTRL+ C
                If Len(ReturnVar$)>0 Then MyName$(13)=ReturnVar$
                
                Case CTRLV$  ' CTRL+ V
                If Len(MyName$(13))=0 Then GoTo SelectEnd
                If Len(MyName$(13)) > Len(ReturnVar$) Then ReturnVar$= left$(MyName$(13),Len(ReturnVar$)) Else ReturnVar$=MyName$(13)
                CursPos% = 1
                
                Case ELSE
                SOUND 500, 1
                End SELECT
SelectEnd:      
                
                END IF
                End IF
                LOOP WHILE NotDone%

'  Exit from here  

                RealStrLen% = LEN(ReturnVar$)
                Xinput$ = ReturnVar$
                END FUNCTION



DefInt A-Z
SUB KillFile (A$)
                nF% = FREEFILE
                OPEN A$ FOR OUTPUT AS #nF%
                CLOSE #nF%
                KILL A$
END Sub




DEFSNG A-Z
FUNCTION WorkOutPath$ (A$, X$)
' Get just the path out of Path+Filename
' Whatever after last "\" gets stripped, and X$ added.
' Examples:   
' 1) Input : A$="c:\MyDir\ti99pc.img", X$=""
'    Output: "c:\MyDir"
'
' 2) Input : A$="c:\MyDir\ti99pc.img", X$="\"
'    Output: "c:\MyDir\"
'
' 3) Input : A$="c:\MyDir\ti99pc.img", X$="\MyApp.dat"
'    Output: "c:\MyDir\MyApp.dat"

                FOR T = LEN(A$) TO 1 STEP -1
                IF MID$(A$, T, 1) = "\" THEN B$ = LEFT$(A$, T - 1): GOTO WorkOutPath2
                NEXT T
WorkOutPath2:   WorkOutPath = B$ + X$
                
END FUNCTION

MyErrorTrap:    MyVal(2) = ERR  ' "ERR" Error I will return with the "ON ERROR" trap. Useful in SUBs/FUNCTIONs. 0=No error
                RESUME NEXT

FUNCTION ValidFullPath(PFN As String,FUNC As Integer)
' Check Path and/or Filename
' PFN$ = Path or Path+Filename to be checked
' FUNC = Desired functions. Each function has an assigned number. Multiple functions can be obtained by summing
'                           together the numerical values of the desired functions. Values are powers of 2=1,2,4,8,16,...
'        1 = Check if path exists. Returns error if path doesn't exist
'        2 = Check if path\filename exists. Returns error if path+filename doesn't exist (file must not be already opened)
'        4 = Check if filename can be created (i.e. if path exists already; if filename is correct and will not conflict with
'            an already existing path in the same directory.

' Returned value
' ValidFullPath = 0 means file is a valid one
' ValidFullPath = ERR Code (76 = Path not found)
' 
' Programmers: please note the correct use of ON ERROR in a FUNCTION or SUB. Label of ON ERROR GOTO *must* be placed 
' outside the FUNCTION/SUB (MyErrorTrap:). There, ERR code is assigned to a SHARED variable, so that the following 
' RESUME NEXT instruction will return the right Error Code to the routine that originally triggered the error. 


                ff% = FREEFILE
                MyVal(2) = 0            ' Assume no error
                On ERROR GOTO MyErrorTrap
                A$ = RTRIM$(PFN$)
                
' Any function Must have a ":" in postion 2
                IF MID$(A$, 2, 1) <> ":" THEN MyVal(2) = 76: GOTO ValidFullP1a ' 76= "Path not found"
                
                CALL ShortLongName(A$,CR$,1) ' Get Short Name out of a long filename
                
' FUNC = 1 Check if path exists (just path, without filename). Return error if path doesn't exist
                IF (FUNC AND 1) > 0 THEN B$ = A$: GOTO ValidFullP1         ' FUNC = 1 : "Check if path exists"
                
' FUNC = 2 Check if path exists. Returns error if path+filename doesn't exist 
' FUNC = 4 Check if filename can be created (i.e. check if path exists already and filename is a possible one
                IF ((FUNC AND 2) = 0) AND ((FUNC AND 4) = 0) THEN GOTO ValidFullP2       ' Skip if FUNC=2 or FUNC=4 are not required
                B$ = WorkOutPath(A$, "")         ' Get bare path (no filename at the end)
                CALL ShortLongName(B$,CR$,1)     ' Get Short Name out of a long filename
                
ValidFullP1:    IF RIGHT$(B$, 1) = "\" THEN B$ = LEFT$(B$, LEN(B$) - 1)
                OPEN B$ + "\CON" FOR INPUT AS #ff%' MyVal(2)=ERR 76 = Path not found
                CLOSE #ff%
                IF MyVal(2) = 0 THEN GOTO ValidFullP2  ' Here OK only if NO ERR code has been reported
                
ValidFullP1a:   Call DispBoxnWait (18,"Error","File "+PFN$+" . Path part is invalid","","","","","") 
                GOTO ValidFullPErr


' FUNC = 2 = Check if path+filename exists. Returns error if path+filename doesn't exist
' Path-Filename must really open a file. See if it does it.
ValidFullP2: 
                IF (FUNC AND 2) = 0 THEN GOTO ValidFullP4
                OPEN A$ FOR INPUT AS #ff%' MyVal(2)=ERR 76 = Path not found
                CLOSE #ff%
                IF MyVal(2) = 0 THEN GOTO ValidFullP4  ' Here OK only if NO ERR code has been reported
                Call DispBoxnWait (18,"Error","File "+PFN$+" does not exist","","","","","")
                GOTO ValidFullPErr

' FUNC =  4 =   Check if filename can be created (i.e. check if path exists already; if filename is correct and will not
'               match the name of an existing directory, in which case there would be an error at creation time.
'
'                         +------------------+
'                         |      START       |
'                         +------------------+ 
'                  NO <---| does path exist? |---> YES
'                ERROR    +-------(1)--------+      |
'                                                   |
'                                   *---------------*
'                                   |
'                   +-----------------------------------+ 
'           NO <--- | can filename be opened as a file ?|---> YES OK File exists
'           |       +-----------------------------------+            already (2)
'           |
'           *------------------------*
'                                    |
'                 +-----------------------------------+                          
'         NO <--- | can filename\CON be still opened ?|---> YES ERROR: FILENAME
'         OK      +-----------------------------------+     IS ACTUALLY A PATH   
'     FILENAME IS                                           (because we saw before
'     NOT A PATH                                             it was not an existing 
'                                                            file)
' 
' .........................................................................................
' Notes
' =====
' (1) Strip away the filename (i.e. get to the first "\" starting from the end of string.
' (2) In QBasic creating a new file or overwriting an old one boils down to be the same operation.


ValidFullP4:
                IF (FUNC AND 4) = 0 THEN GOTO ValidFullPOK
'  Filename cannot be name of an existing directory. But if it is, and isn't an existing file, then path$\CON can be opened: aha...
                OPEN A$ FOR INPUT AS #ff%' MyVal(2)=ERR 76 = Path not found
                CLOSE #ff%
                IF MyVal(2) = 0 THEN GOTO ValidFullPOK ' File already exists
                MyVal(2) = 0
                OPEN A$ + "\CON" FOR INPUT AS #ff%' MyVal(2)=ERR 76 = Path not found
                CLOSE #ff%
                IF MyVal(2) <> 0 THEN GOTO ValidFullPOK  ' Here OK only if an ERR code has been reported
ValidFullP4Err: Call DispBoxnWait (18,"Error","File "+PFN$, "is the name of an already existing directory","","","","") 
                MyVal(2) = 76
                GOTO ValidFullPErr

ValidFullPOK:   ValidFullPath = 0
                GOTO ValidFullPEnd
ValidFullPErr:
                ValidFullPath = MyVal(2)
ValidFullPEnd:
                MyVal(2) = 0
                ON ERROR GOTO 0
END FUNCTION
DEFINT A-Z
SUB DispBoxnWait (StRow%,A1$,A2$,A3$,A4$,A5$,A6$,RetKey$)
' Call DispBoxnWait$(StartRow,"Error","This file ","c:\temp\myfile.txt ", "does not exist"," ",CHR$(10))
' Rules: 
' 1) Empty string will have no action: is as if the parameter did not exist. If all strings are empty, exit with no action
' 2) A string containing just one character which is a blank will be printed as a line
' 4) If caller's RetKey$ is an empty string, add 2 extra lines to the box, print "- Press any key -", centered.
'    If caller's RetKey$ is NOT an empty string, print that string as the last one in the box,  centered.
'    In both the above cases, wait for a user's key pressed and return the pressed key to the caller in RetKey$. 
'    If caller's RetKey$ is CHR$(10) then exit right away (no wait). 
'    
'    the caller in RetKey$
Dim DBW$(7)
                DBW$(1)=A1$
                DBW$(2)=A2$
                DBW$(3)=A3$
                DBW$(4)=A4$
                DBW$(5)=A5$
                DBW$(6)=A6$
                
' Work out max string length
                For T=1 To 6
                If DBW$(T)="" Then GoTo DispBoxn6
                If Len(DBW$(T)) > MLen% Then MLen%=Len(DBW$(T))
DispBoxn5:      Lin%=Lin%+1
DispBoxn6:      Next t
' End of String Length Check
                If MLen%>76 Then MLen%=76
                If Lin%=0 Then RetKey$="" : GoTo DispBoxnEnd
                If RetKey$=CHR$(10) Then A=0 Else A=2
'Print RetKey$                  
                CALL box(StRow%, 40-Int((MLen%/2)+.5),MLen%+2+1 , Lin%+2+A, DoubleBorder$)
                
                Lin%=0
                For T=1 To 6
                LOCATE StRow%+1+Lin%, 40-Int((MLen%/2)+.5)+1
                If DBW$(T)="" Then GoTo DispBoxn16
                Print  LEFT$(DBW$(T),77)
                Lin%=Lin%+1
DispBoxn16:     Next T

DispBoxn20:     If RetKey$=CHR$(10) Then  RetKey$="": GoTo DispBoxnEnd
                If RetKey$<>"" Then  B$=RetKey$ : GoTo DispBoxn30
                B$= " - Press any key to exit -"
DispBoxn30:     
                LOCATE StRow%+Lin%+A, 40-Int((Len(B$)/2)+.5)+1
                Print B$
                LOCATE StRow%+Lin%+A, 40 +Int((Len(B$)/2)+.5)+1
                DO: DU$ = INKEY$: LOOP UNTIL DU$ <> ""
                RetKey$=DU$

DispBoxnEnd:                    

END SUB 

DEFINT A-Z
SUB ThisHelp (Banner$, DatFile$, IDXFile$, Argum$)
		
		GOTO GetHelp

' Because of MS QBasic quirks, GetIDX routine has to be placed before the rest of the code.

' Get .IDX file values into an array, that is,
' Get Array Parameters from Index (IDX) file
GetIDX:
		OPEN IDXFile$ FOR RANDOM ACCESS READ AS #3 LEN = LEN(IDXRecord)
		GET #3, , IDXRecord
		TLines% = IDXRecord.StartRec' First record is special: total records that follow
		
		
		REDIM IDXSect$(TLines%)
		REDIM IdxStart(TLines%)
		REDIM IdxLength(TLines%)
		FOR T = 1 TO TLines%
		GET #3, , IDXRecord
		IDXSect$(T) = LTRIM$(IDXRecord.Section)
		IdxStart(T) = IDXRecord.StartRec
		IdxLength(T) = IDXRecord.RecLength
		IDXSect$(T) = LTRIM$(RTRIM$(IDXSect$(T)))
		NEXT T
		CLOSE #3
		RETURN
		

		
		
GetHelp:        CLS
		LOCATE 1, 26: PRINT Banner$
		InizRw% = 2
		TotScrRws% = 12
		CurrScrRw% = 1
		
		GOSUB RedrawBox
		GOSUB GetIDX
		FOR Arg% = 1 TO TLines%
		IF Argum$ = IDXSect$(Arg%) THEN GOTO ArgFnd
		NEXT Arg%
		Arg% = 1
		
ArgFnd:         CurntLine% = Arg%
		RcLen% = 77 + 2
		OPEN DatFile$ FOR RANDOM ACCESS READ AS #59 LEN = RcLen%
		FIELD #59, RcLen% - 2 AS DL$
		FIELD #59, 2 AS CRLF$
		
'===================================
' MAIN LOOP STARTS HERE
'===================================
NextLineName:
		COLOR 7,0 ' FC, BC
		
		IF CurrScrRw% = 1 THEN FstLine% = CurntLine%   ' Get Number of first Line only
		GOSUB DisplayRw
		CurntLine% = CurntLine% + 1 ' Next Line
		LastScrRw% = CurrScrRw%      ' Save last Screen Row used
		CurrScrRw% = CurrScrRw% + 1  ' Next Screen Row
		IF CurrScrRw% < TotScrRws% + 1 AND CurntLine% <= TLines% THEN GOTO NextLineName
'===================================
' MAIN LOOP ENDS HERE
'===================================
'
		GOSUB BotLine              ' Clear Unused Bottom Lines
		LastLine% = CurntLine% - 1
		CurntLine% = FstLine%  ' Current Line is now first Line in screen
		
		CurrScrRw% = 1
		IF KeepCursBot% = 0 THEN GOTO LocCursor2
		' Last key used was Arrow Down. Move Cursor and FileNumber pointer to last Line in Screen
		CurrScrRw% = TotScrRws%: KeepCursBot% = 0: CurntLine% = LastLine%
		GOTO LocCursor2
		
LocCursor:
		GOSUB HeRestColor

LocCursor2:
		LOCATE InizRw% + CurrScrRw%, 2, 1
		COLOR 7, 0: GOSUB DisplayRw ' Display Current Row
		LOCATE InizRw% + CurrScrRw%, 2, 1
		OldScrRw% = CurrScrRw%
		OldLine% = CurntLine%
		IF GoToThisDir% <> 0 THEN CurntLine% = GoToThisDir%: GoToThisDir% = 0: GOTO Exekit
		'GOSUB ShowValues    ' My little Debugger
		
		
DoHeAgain:      GOSUB GetChar

		' IF INSTR(AllowedKey$, UH$) = 0 THEN GOTO DoHeAgain

		' ESCape Key
		IF UH$ = CHR$(27) THEN GOTO HAbort
		
		' ENTER Key
		IF UH$ <> CHR$(13) THEN GOTO IsArrDown
EnterKey:       CALL Fischio
		GOSUB ThisSect
		GOSUB RePaintHelp
		GOTO NMatch

IsArrDown:     ' Arrow Down Key
		IF UH$ <> CHR$(0) + CHR$(80) THEN GOTO OthKey0
		IF CurrScrRw% < LastScrRw% THEN CurrScrRw% = CurrScrRw% + 1: CurntLine% = CurntLine% + 1: GOTO LocCursor
		IF CurntLine% = TLines% THEN GOTO LocCursor
		CurntLine% = FstLine% + 1
		KeepCursBot% = 1
		IF CurntLine% < 1 THEN CurntLine% = 1
		GOTO Exekit
OthKey0:         'Arrow up Key
		IF UH$ <> CHR$(0) + CHR$(72) THEN GOTO OthKey1
		IF CurntLine% = 1 THEN GOTO NMatch
		IF CurrScrRw% > 1 THEN CurrScrRw% = CurrScrRw% - 1: CurntLine% = CurntLine% - 1: GOTO LocCursor
		CurntLine% = FstLine% - 1: IF CurntLine% < 1 THEN CurntLine% = 1
		GOTO Exekit
		
OthKey1:         ' Page Up Key
		IF UH$ <> CHR$(0) + CHR$(73) THEN GOTO OthKey2
		CurntLine% = FstLine% - TotScrRws%
		IF CurntLine% < 1 THEN CurntLine% = 1
		GOTO Exekit

OthKey2:        ' Page Down Key
		IF UH$ <> CHR$(0) + CHR$(81) THEN GOTO OthKey7
		IF LastLine% + 1 + TotScrRws% > TLines% THEN CurntLine% = TLines% - TotScrRws% + 1: IF CurntLine% < 1 THEN CurntLine% = 1: GOTO Exekit
		CurntLine% = FstLine% + TotScrRws%
		IF CurntLine% > TLines% THEN CurntLine% = FstLine%
		GOTO Exekit
		
OthKey7:         ' Home Key : simply move cursor to top
		IF UH$ <> CHR$(0) + CHR$(71) THEN GOTO OthKey8
		CurrScrRw% = 1: CurntLine% = FstLine%: GOTO LocCursor

OthKey8:         ' End Key : simply move cursor to bottom
		IF UH$ <> CHR$(0) + CHR$(79) THEN GOTO OthKey9
		CurrScrRw% = LastScrRw%: CurntLine% = LastLine%
		GOTO LocCursor
		
OthKey9:        ' F3 = Show Error List
		IF UH$ <> CHR$(0) + CHR$(61) THEN GOTO OthKey10
		GOSUB RePaintHelp
		GOTO NMatch

OthKey10:       ' F7 = Show Sector as Hex
		IF UH$ <> CHR$(0) + CHR$(65) THEN GOTO OthKey11
		GOSUB RePaintHelp
		GOTO NMatch
		
OthKey11:       'CTRL Page Down
		IF UH$ <> CHR$(0) + CHR$(118) THEN GOTO OthKey12
		GOTO EnterKey
OthKey12:
		GOTO NMatch


Exekit:         CurrScrRw% = 1     ' Cursor on first screen row
		LOCATE InizRw% + CurrScrRw%, 2, 1
		GOTO NextLineName   ' Start next round

NMatch:         GOTO LocCursor
		
RePaintHelp:
		GOSUB RedrawBox
		SaveCurrLine% = CurntLine%
		SavCurrScrRw% = CurrScrRw%
		CurntLine% = FstLine%
		FOR CurrScrRw% = 1 TO TotScrRws%
		GOSUB DisplayRw  ' Display Current Row
		CurntLine% = CurntLine% + 1 ' Next Line
		LastScrRw% = CurrScrRw%      ' Save last Screen Row used
		IF CurntLine% > TLines% THEN CurrScrRw% = CurrScrRw% + 1: GOTO RePaintHelp2
		NEXT CurrScrRw%   ' Next Screen Row
		
RePaintHelp2:
		
		CurntLine% = SaveCurrLine%
		CurrScrRw% = SavCurrScrRw%
		RETURN

HeRestColor:    TempScreenRw% = CurrScrRw%
		TempLine% = CurntLine%
		CurrScrRw% = OldScrRw%
		CurntLine% = OldLine%
		COLOR 7, 0: GOSUB DisplayRw' Display Current Row
		CurrScrRw% = TempScreenRw%
		CurntLine% = TempLine%
		RETURN

'==========================
' DISPLAY CURRENT ROW
'==========================
DisplayRw:
		LOCATE InizRw% + CurrScrRw%, 2, 1
		GET #59, IdxStart(CurntLine%)
		TL$ = DL$
		FOR T = 1 TO LEN(TL$): IF MID$(TL$, T, 1) <> " " AND MID$(TL$, T, 1) <> "*" THEN GOTO StrtFound
		NEXT T
StrtFound:      TL$ = RIGHT$(TL$, LEN(TL$) - T + 1)
		
		FOR T = LEN(TL$) TO 1 STEP -1: IF MID$(TL$, T, 1) <> " " AND MID$(TL$, T, 1) <> "*" THEN GOTO EndFnd
		NEXT T
EndFnd:         TL$ = LEFT$(TL$, T)
		PRINT IDXSect$(CurntLine%); TAB(12); TL$; SPACE$(79 - 12 - LEN(TL$));
		RETURN
		
'====================
' CLEAR BOTTOM LINES
'====================
BotLine:
		
		LOCATE InizRw% + CurrScrRw%, 2, 1

		IF CurrScrRw% >= TotScrRws% THEN GOTO HlpClear ' Blank all unused screen rows, if any

		FOR V = CurrScrRw% TO TotScrRws%
		LOCATE InizRw% + V, 2, 1
		PRINT "                                                                              "
		NEXT V
		
HlpClear:       LOCATE 23, 1: PRINT "Enter=Get Doc. ArrowUp, ArrowDown, PageUp, PageDown to move around. ESC=Exit"
		RETURN

		
' Create Box
RedrawBox:      CALL box(2, 1, 80, TotScrRws% + 2,DoubleBorder$)
		RETURN
Pranyk:

		PRINT "                         - press any key to return -"
		GOSUB GetChar
		RETURN
		
GetChar:
		DO: UH$ = INKEY$: LOOP UNTIL UH$ <> ""
		RETURN


ThisSect:       TotSectRws% = 19
		SectInizRw% = 2
		SectCurrRw% = 1
		SectStart& = IdxStart(CurntLine%)
		SectCount& = IdxLength(CurntLine%)
		SectCurr& = 0
		Blank$ = SPACE$(78)
		LOCATE 23, 1: PRINT "Enter=Line Down. ArrowUp, ArrowDown, PageUp, PageDown to move around. ESC=Exit"
		CALL box(2, 1, 80, TotSectRws% + 2,DoubleBorder$)
NewRound:
		FirstRec& = SectCurr&
SectNewLine:
		GET #59, SectStart& + SectCurr&
		LOCATE SectInizRw% + SectCurrRw%, 2, 1
		PRINT DL$;
		SectCurr& = SectCurr& + 1
		LastSectRw% = SectCurrRw%      ' Save last Screen Row used
		SectCurrRw% = SectCurrRw% + 1
		IF SectCurrRw% < TotSectRws% + 1 AND SectCurr& < SectCount& THEN GOTO SectNewLine
		
		FOR V = SectCurrRw% TO TotSectRws%
		LOCATE SectInizRw% + V, 2
		PRINT Blank$;
		NEXT V
		
GetAnother:     GOSUB GetChar
		'IF INSTR(AllowedKey$, UH$) = 0 THEN GOTO GetAnother
		SectCurr& = FirstRec&
		SectCurrRw% = 1
		' ESC Key
		IF UH$ = CHR$(27) THEN GOTO SectExit
		
		' ENTER Key
		IF UH$ <> CHR$(13) THEN GOTO SectArrowDown
SectEnter:      IF SectCurr& < SectCount& - 6 THEN SectCurr& = SectCurr& + 1
		GOTO NewRound
		
SectArrowDown:  ' Arrow Down Key
		IF UH$ <> CHR$(0) + CHR$(80) THEN GOTO SectKey0
		GOTO SectEnter
		
SectKey0:       'Arrow up Key
		IF UH$ <> CHR$(0) + CHR$(72) THEN GOTO SectKey1
		IF SectCurr& > 0 THEN SectCurr& = SectCurr& - 1
		GOTO NewRound
SectKey1:
		' Page Up Key
		IF UH$ <> CHR$(0) + CHR$(73) THEN GOTO SectKey2
SectPageUp:     SectCurr& = SectCurr& - TotSectRws%
		IF SectCurr& < 0 THEN SectCurr& = 0
		GOTO NewRound
		
SectKey2:        ' Page Down Key
		IF UH$ <> CHR$(0) + CHR$(81) THEN GOTO SectKey11
SectPageDown:   SectCurr& = SectCurr& + TotSectRws%
		IF SectCurr& > SectCount& - TotSectRws% THEN SectCurr& = SectCount& - TotSectRws%
		IF SectCurr& < 0 THEN SectCurr& = 0
		GOTO NewRound
		
SectKey11:      'CTRL Page Down
		IF UH$ <> CHR$(0) + CHR$(118) THEN GOTO SectKey12
		GOTO SectPageDown
		
SectKey12:      'CTRL Page Up
		IF UH$ <> CHR$(0) + CHR$(132) THEN GOTO SectKey13
		GOTO SectPageUp
SectKey13:
		GOTO NewRound
SectExit:
		V = InizRw% + TotScrRws%
		LOCATE V, 1, 1
		IF V >= 22 THEN GOTO DontDoit ' Blank all unused screen rows, if any

		FOR V = V TO 23
		LOCATE V, 1, 1
		PRINT SPACE$(80)
		NEXT V
DontDoit:
		
		RETURN
HAbort:
		CLOSE #59
END SUB
